# - Looking for the iconv.h header file on Windows

IF(WIN32)
    MESSAGE(STATUS "Looking for IConv...")

    # Find iconv.dll in PATH
    MARK_AS_ADVANCED(ICONV_DLL_PATH)
    FIND_PATH(ICONV_DLL_PATH NAMES iconv.dll PATHS ENV PATH)
    # Find iconv.h in ${ICONV_LIB}/include
    STRING(REGEX REPLACE "(.*)/bin" "\\1" ICONV_DIR "${ICONV_DLL_PATH}")
	# STRING(REGEX REPLACE "(.*)\bin" "\\1" ICONV_DIR "${ICONV_DLL_PATH}")
    FIND_PATH(ICONV_INCLUDE_DIR NAMES iconv.h PATHS ${ICONV_DIR}/include)

    IF(${ICONV_INCLUDE_DIR} MATCHES "ICONV_INCLUDE_DIR-NOTFOUND")
        # If not found, then use the embedded one
        SET(ICONV_INCLUDE_DIR ${URANIE_SOURCE_DIR}/adm/windows/)
        MESSAGE(STATUS "Looking for IConv header... - Not found in PATH. Using the embedded one.")
    ELSE(${ICONV_INCLUDE_DIR} MATCHES "ICONV_INCLUDE_DIR-NOTFOUND")
        MESSAGE(STATUS "Looking for IConv header... - Found")
    ENDIF(${ICONV_INCLUDE_DIR} MATCHES "ICONV_INCLUDE_DIR-NOTFOUND")
ENDIF(WIN32)
