# Locate PCL Library
# this modules defines
#  PCL_FOUND
#  PCL_INCLUDE_DIR
#  PCL_LIBRARIES
#  PCL_LIBS


FIND_LIBRARY(PCL_LIBRARIES
    NAMES pcl
    HINTS ENV LD_LIBRARY_PATH ENV PATH
    PATH_SUFFIXES lib64 lib debug release
    PATHS
    /usr/local
    /usr
	PATH
)


IF(PCL_LIBRARIES)
  if(UNIX)
      STRING(REGEX REPLACE "(.*)/lib[^ /]*/libpcl.so" "\\1" PCL_LIBS "${PCL_LIBRARIES}")
  else(UNIX)
      STRING(REGEX REPLACE "(.*)/release/pcl.lib" "\\1" PCL_LIBS "${PCL_LIBRARIES}")
  endif(UNIX)
ENDIF(PCL_LIBRARIES)

FIND_PATH(PCL_INCLUDE_DIR pcl.h
    PATH_SUFFIXES include
    PATHS
	ENV PATH
    ${PCL_LIBS}
    /usr/local
    /usr
)
set(PCL_LIBRARY ${PCL_LIBS})


#INCLUDE(${CMAKE_CURRENT_LIST_DIR}/FindPackageHandleStandardArgs.cmake)
FIND_PACKAGE_HANDLE_STANDARD_ARGS(PCL DEFAULT_MSG PCL_LIBRARIES PCL_INCLUDE_DIR)
MARK_AS_ADVANCED(PCL_INCLUDE_DIRS PCL_LIBRARIES)


