


#-------------------------------------------------------------------------
# CPack Configuration
#-------------------------------------------------------------------------
set(CPACK_PACKAGE_VERSION ${URANIE_VERSION})
set (CPACK_PACKAGE_VERSION_MAJOR ${URANIE_VERSION_MAJOR})
set (CPACK_PACKAGE_VERSION_MINOR ${URANIE_VERSION_MINOR})
set (CPACK_PACKAGE_VERSION_PATCH ${URANIE_VERSION_PATCH})

#-------------------------------------------------------------------------
# Set system and generator for Unix
#-------------------------------------------------------------------------

if(UNIX)
    set(CPACK_SYSTEM_NAME "Linux")
    set(CPACK_CMAKE_GENERATOR "Unix Makefiles")
endif(UNIX)

#-------------------------------------------------------------------------
# Set system and generator for Windows
#-------------------------------------------------------------------------

if(WIN32)
    set(CPACK_SYSTEM_NAME "Windows")
    set(CPACK_CMAKE_GENERATOR "Visual Studio")
endif(WIN32)


#-------------------------------------------------------------------------
# Specify the package data format
#-------------------------------------------------------------------------

set(CPACK_GENERATOR TGZ)
set(CPACK_SOURCE_GENERATOR TGZ)

#-------------------------------------------------------------------------
# Set source files to ignore in source package
#-------------------------------------------------------------------------

set (CPACK_SOURCE_IGNORE_FILES
    ".git"
    ".gitignore"
    ".*\\\\.cvsignore"
    ".*\\\\~"
    "cmake_uninstall.cmake"
    "configure.in"
    "CTestConfig.cmake"
    "Testing.cmake"
    "TestingDI.cmake"
)

#-------------------------------------------------------------------------
# Include CPack (always last instruction)
#-------------------------------------------------------------------------

include(CPack)

