<?xml version="1.0" encoding='ISO-8859-1' standalone='yes' ?>
<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
  xmlns:exsl="http://exslt.org/common"
  xmlns:date="http://exslt.org/dates-and-times"
  extension-element-prefixes="date">
  
  <!--  <xsl:import href="functions/difference/date.difference.xsl"/> -->
  <!--  <xsl:import href="functions/format-date/date.format-date.xsl"/> -->

  <!-- <xsl:import href="functions/parse-date/date.parse-date.xsl"/> -->
  
  <!--     <xsl:import href="date.xsl.original" /> -->
  <!--     <xsl:import href="eXSLT/date/date.xsl" /> -->
       
    <xsl:template match="/">
      <HTML>
        <HEAD>
          <TITLE>Test Report : Folder <xsl:apply-templates select="/files/folder"/> - </TITLE>
          <STYLE>
TABLE		{ color:#222222; font-size:10pt; font-family:'lr SVbN' 'sanserif'; }
TH		{ font-weight:normal; color:#FFFFFF; background-color:#888888; }
TR.check	{ background-color:#EEEEEE }
TD.check	{ background-color:#EEEEEE }
H1		{ color:#111111; ; border-style:solid; border-width:0px; border-bottom-width:3px; border-bottom-color:#444488; }
H2		{ color:#222222; ; border-style:solid; border-width:0px; border-bottom-width:2px; border-bottom-color:#444488; }
H3		{ color:#333333; ; border-style:solid; border-width:0px; border-bottom-width:0px; border-bottom-color:#444488; margin-bottom:8px; }
H4		{ color:#444444; ; border-style:solid; border-width:0px; border-bottom-width:1px; border-bottom-color:#CCCCDD; margin-bottom:8px; }
H5		{ color:#555555; ; border-style:solid; border-width:0px; border-bottom-width:1px; border-bottom-color:#EEEEFF; margin-bottom:8px; }
H6		{ color:#666666; ; border-style:solid; border-width:0px; border-bottom-width:1px; border-bottom-color:#F8F8FF; margin-bottom:8px; }
SPAN.good	{ color:#006666; font-weight:bold; }
SPAN.critical	{ color:#880000; font-weight:bold; }
</STYLE>
</HEAD>
<BODY>
  <H1>Unit Testing Report</H1>
  <xsl:apply-templates select="/synthesis"/>
</BODY>
</HTML>
</xsl:template>



<xsl:template match="/synthesis">
  
    <table border="1" cellspacing="0" cellpadding="5">
      
      <!-- ================================================================= -->
      <!--        Ligne des titres                                           -->
      <!-- ================================================================= -->
      <tr>
        <th></th>
        <xsl:for-each select="/synthesis/files/file">
          <xsl:variable name="resultFile"><xsl:value-of select="@name"/></xsl:variable>
          <th><a href="{$resultFile}"><xsl:value-of select="."/> </a></th>
        </xsl:for-each>
      </tr>

  <!-- ================================================================= -->
  <!--         Status                                                    -->
  <!-- ================================================================= -->
          <tr>
            <td>Status</td>
            <xsl:for-each select="/synthesis/files/file">
              <xsl:variable name="resultFile"><xsl:value-of select="@name"/></xsl:variable>

                <xsl:choose>
                  <xsl:when test="document($resultFile)/TestRun/Statistics/FailuresTotal &gt; 0">
                    <td  align="center" style="color: #FF0000">FAILED</td>
                  </xsl:when>
                  <xsl:when test="document($resultFile)/TestRun/Statistics/FailuresTotal = 0">
                    <td  align="center" style="color: #00CC00">PASSED</td>
                  </xsl:when>
                  <xsl:otherwise>
                    <td align="center" style="color: #FFCC33">NOT RUN</td>
                  </xsl:otherwise>
                </xsl:choose>
                   
            </xsl:for-each>
          </tr>

  <!-- ================================================================= -->
  <!--         Duration time                                             -->
  <!-- ================================================================= -->
          <tr>
            <td>Duration</td>
            <xsl:for-each select="/synthesis/files/file">
              <xsl:variable name="resultFile"><xsl:value-of select="@name"/></xsl:variable>
              <xsl:variable name="sFormat">MMM dd, yyyy</xsl:variable>
              <xsl:variable name="theBEGINx">
                <xsl:apply-templates select="document($resultFile)/TestRun/TimeInfo/Begin"/>
              </xsl:variable>
              <!-- <xsl:variable name="theBEGINs" select="date:date-time()"/> -->
              <!--               <xsl:variable name="theBEGINss" select="date:format-date($theBEGIN,'dd MMMMM yyyy')"/> -->
              <xsl:variable name="theENDx">
                <xsl:apply-templates select="document($resultFile)/TestRun/TimeInfo/End"/>
              </xsl:variable>
              
              <!-- <xsl:variable name="time-diff-sec" select="date:seconds(date:difference($theBEGIN, $theEND))"/> -->
              
              <td align="center"></td>
            </xsl:for-each>
          </tr>

  <!-- ================================================================= -->
  <!--         Number Of Tests                                           -->
  <!-- ================================================================= -->
          <tr>
            <td><em>Num.</em> test</td>
            <xsl:for-each select="/synthesis/files/file">
              <xsl:variable name="resultFile"><xsl:value-of select="@name"/></xsl:variable>
              <xsl:variable name="actual"><xsl:value-of select="document($resultFile)/TestRun/Statistics/Tests"/></xsl:variable>
              <xsl:variable name="expected"><xsl:value-of select="@value"/></xsl:variable>
              <xsl:choose>
                <xsl:when test="$actual = $expected">
                  <td align="center">
                    <a style="color: #00CC00">
                      <xsl:attribute name="href"><xsl:value-of select="$resultFile"/></xsl:attribute>
                      <xsl:attribute name="target">_blank</xsl:attribute>
                      <xsl:value-of select="$actual"/>
                    </a>                    
                  </td>
                </xsl:when>
                <xsl:otherwise>
                  <td align="center" style="color: #FF9900">
                    <a style="color: #00CC00"> <xsl:attribute name="href"><xsl:value-of select="$resultFile"/></xsl:attribute> <xsl:value-of select="$actual"/> </a> / <xsl:value-of select="$expected"/>
                  </td>
                </xsl:otherwise>
              </xsl:choose>
            </xsl:for-each>
          </tr>

  <!-- ================================================================= -->
  <!--         Total Failures                                            -->
  <!-- ================================================================= -->
          <tr>
            <td>Total Failures</td>
            <xsl:for-each select="/synthesis/files/file">
              <xsl:variable name="resultFile"><xsl:value-of select="@name"/></xsl:variable>
              <td align="center"><b><xsl:apply-templates select="document($resultFile)/TestRun/Statistics/FailuresTotal"/></b></td>
            </xsl:for-each>
          </tr>
          
  <!-- ================================================================= -->
  <!--         Number Of Errors                                          -->
  <!-- ================================================================= -->
          <tr>
            <td><em>Num.</em> Errors</td>
            <xsl:for-each select="/synthesis/files/file">
              <xsl:variable name="resultFile"><xsl:value-of select="@name"/></xsl:variable>
              <td align="right"><xsl:apply-templates select="document($resultFile)/TestRun/Statistics/Errors"/></td>
            </xsl:for-each>
          </tr>

  <!-- ================================================================= -->
  <!--         Number Of Failures                                        -->
  <!-- ================================================================= -->
          <tr>
            <td><em>Num.</em> Failures</td>
            <xsl:for-each select="/synthesis/files/file">
              <xsl:variable name="resultFile"><xsl:value-of select="@name"/></xsl:variable>
              <td align="right"><xsl:apply-templates select="document($resultFile)/TestRun/Statistics/Failures"/></td>
            </xsl:for-each>
          </tr>

  <!-- ================================================================= -->
  <!--         Start time                                                -->
  <!-- ================================================================= -->
  <tr> 
  <td><em>Start</em></td>
  <xsl:for-each select="/synthesis/files/file">
    <xsl:variable name="resultFile"><xsl:value-of select="@name"/></xsl:variable>
    <xsl:variable name="theBeginString">
      <xsl:apply-templates select="document($resultFile)/TestRun/TimeInfo/Begin"/>
    </xsl:variable>
    <td align="center">
        <b><xsl:value-of select="substring-before($theBeginString, 'T')"/></b><br></br>
        <b><xsl:value-of select="substring-after($theBeginString, 'T')"/></b><br></br>
    </td>
  </xsl:for-each>
  </tr>

  <!-- ================================================================= -->
  <!--         Stop time                                                 -->
  <!-- ================================================================= -->
  <tr>
    <td><em>End</em></td>
    <xsl:for-each select="/synthesis/files/file">
      <xsl:variable name="resultFile"><xsl:value-of select="@name"/></xsl:variable>
      <xsl:variable name="theEndString">
        <xsl:apply-templates select="document($resultFile)/TestRun/TimeInfo/End"/>
      </xsl:variable>
      <td align="center">
        <b><xsl:value-of select="substring-before($theEndString, 'T')"/></b><br></br>
        <b><xsl:value-of select="substring-after($theEndString, 'T')"/></b>
      </td>
    </xsl:for-each>
  </tr>


  <!-- ================================================================= -->
  <!--         End Of Table                                              -->
  <!-- ================================================================= -->
    </table>

  <footnotes>
    <hr></hr>
    <em>
    Files (<xsl:value-of  select="date:date-time()"/>) : 
    <ul>
      <li> XML  :  UTReport.xml  </li>
      <li> XSL  :  UTReport.xsl  </li>
    </ul>
  </em>
  </footnotes>

</xsl:template>
</xsl:stylesheet>
