//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2022 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision$
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TestQuantiles.h
 \author Nicolas Gilardi <nicolas.gilardi@cea.fr>
 \date   $Date$
 
 \brief  Test file of the TDataServer quantile computation functions
 
 Created: 2010-02-17 09:14:10
 
 */
#ifndef CPPUNITEST_QUANTILES_H
#define CPPUNITEST_QUANTILES_H

//CPPUNIT
#include <cppunit/extensions/HelperMacros.h>
//#include <cppunit/portability/CppUnitDeque.h>
#include <cppunit/Test.h>
#include <cppunit/TestFailure.h>
#include <cppunit/TestResultCollector.h>

//URANIE
#include "TDataServer.h"

class QuantilesTest: public CPPUNIT_NS::TestFixture
{
    CPPUNIT_TEST_SUITE (QuantilesTest);
    CPPUNIT_TEST (testMethods);
    CPPUNIT_TEST (testOrder);CPPUNIT_TEST_SUITE_END();

public:
    QuantilesTest();

    /// Destructor.
    virtual ~QuantilesTest();

    void setUp();
    void tearDown();
    //---------------------------------------------
    /** @name Unit Tests
     The list of unit test
     **/
    //@{
    //! Test the 9 different quantile computation methods
    void testMethods();
    void testOrder();
    //@}

private:
    Int_t nx, nProba;
    Double_t *x, *mixed_x, *proba, *quantiles, *quantileValueRef;
    URANIE::DataServer::TDataServer *tds;

};

#endif  // CPPUNITEST_QUANTILES_H
