//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2022 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision$
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TestTAttributeFormula.h
 \author C�dric Forgues (C.S.) <uranietm@cea.fr>
 \date   $Date$
 
 \brief  Fichier de test de la classe URANIE::DataServer::TAttributeFormula
 
 Cr�e le : mar avri 26 10:00:00 2010

 // *****************************************************************************

 */
#ifndef CPPUNITEST_TATTRIBUTEFORMULA_H
#define CPPUNITEST_TATTRIBUTEFORMULA_H

#include <cppunit/extensions/HelperMacros.h>
//#include <cppunit/portability/CppUnitDeque.h>
#include <cppunit/Test.h>
#include <cppunit/TestFailure.h>
#include <cppunit/TestResultCollector.h>

#include "TAttributeFormula.h"
#include "UExceptions.h"

/*! \class TAttributeFormulaTest
 * \brief Unit tests for TAttributeFormula.
 */
class TAttributeFormulaTest: public CPPUNIT_NS::TestFixture
{
    CPPUNIT_TEST_SUITE (TAttributeFormulaTest);
    CPPUNIT_TEST (testGetSetFormula);
    CPPUNIT_TEST (throwExceptionNoFormula);CPPUNIT_TEST_SUITE_END();

public:
    /*! Constructs a TAttributeFormulaTest object.
     */
    TAttributeFormulaTest();

    /// Destructor.
    virtual ~TAttributeFormulaTest();

    void setUp();
    void tearDown();

    //---------------------------------------------
    /** @name Unit Tests
     The list of unit test
     **/
    //@{
    //! Tests the getFormula() and setFormula() methods.
    void testGetSetFormula();

    //! Throws an exception when no formula is entered in cosntructor.
    void throwExceptionNoFormula();

    //@}

private:
    URANIE::DataServer::TAttributeFormula * taf;
};
#endif  // CPPUNITEST_TATTRIBUTEFORMULA_H
