#ifndef TPCATEST_H
#define TPCATEST_H

#include <cppunit/extensions/HelperMacros.h>

#include "UExceptions.h"

class TPCATest: public CPPUNIT_NS::TestFixture {
    CPPUNIT_TEST_SUITE(TPCATest);
    CPPUNIT_TEST_EXCEPTION(throwNullTDataServerPointer, URANIE::Exceptions::UErrorExceptions);
    CPPUNIT_TEST_EXCEPTION(throwEmptyTDataServer, URANIE::Exceptions::UErrorExceptions);
    CPPUNIT_TEST_EXCEPTION(throwStringAttribute, URANIE::Exceptions::UErrorExceptions);
    CPPUNIT_TEST(testDestruction);
#ifdef WITH_DATAFRAME
    CPPUNIT_TEST(testMarksResultsAndVariables);
    CPPUNIT_TEST(testDecathlonResultsAndVariables);
#endif    
    CPPUNIT_TEST_SUITE_END();
public:
    void throwNullTDataServerPointer();
    void throwEmptyTDataServer();
    void throwStringAttribute();
    void testDestruction();
#ifdef WITH_DATAFRAME    
    void testMarksResultsAndVariables();
    void testDecathlonResultsAndVariables();
#endif
};

#endif
