//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2022 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision$
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TestTTokenizer.h
 \author C�dric Forgues (C.S.) <uranietm@cea.fr>
 \date   $Date$
 
 \brief  Fichier de test de la classe TTokenizer.
 
 Cr�e le : jeu jun 16 2010/06/16 2010
 
 */
#ifndef CPPUNITEST_TTOKENIZER_H
#define CPPUNITEST_TTOKENIZER_H

#include <cppunit/extensions/HelperMacros.h>
//#include <cppunit/portability/CppUnitDeque.h>
#include <cppunit/Test.h>
#include <cppunit/TestFailure.h>
#include <cppunit/TestResultCollector.h>

#include "TTokenizer.h"

/*! \class TTokenizerTest
 * \brief Unit tests for TTokenizer.
 */
class TTokenizerTest: public CPPUNIT_NS::TestFixture
{
    CPPUNIT_TEST_SUITE (TTokenizerTest);
    CPPUNIT_TEST (testGetTokens);
    CPPUNIT_TEST (testSetComment);
    CPPUNIT_TEST (testSetDelimiters);
    CPPUNIT_TEST (testIsSetQuotes);CPPUNIT_TEST_SUITE_END();

public:
    /*! Constructs a TTokenizerTest object.
     */
    TTokenizerTest();

    /// Destructor.
    virtual ~TTokenizerTest();

    void setUp();
    void tearDown();

    //---------------------------------------------
    /** @name Unit Tests
     The list of unit test
     **/
    //@{
    //! Tests the getTokens() method.
    void testGetTokens();

    //! Tests the setComment() method.
    void testSetComment();

    //! Tests the setDelimiters() method.
    void testSetDelimiters();

    //! Tests the setQuotes() method.
    void testIsSetQuotes();
    //@}

private:
    TTokenizer * token;
};

#endif  // CPPUNITEST_TTOKENIZER_H
