//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2022 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
#ifndef CPPUNITEST_TCLUSTER_H
#define CPPUNITEST_TCLUSTER_H

#include <cppunit/extensions/HelperMacros.h>
//#include <cppunit/portability/CppUnitDeque.h>
#include <cppunit/Test.h>
#include <cppunit/TestFailure.h>
#include <cppunit/TestResultCollector.h>

// Uranie
#include "TLauncher.h"
#include "TDataServer.h"
#include "UExceptions.h"

class TClusterTest: public CPPUNIT_NS::TestFixture
{
    CPPUNIT_TEST_SUITE (TClusterTest);
#ifdef UNIX
    CPPUNIT_TEST( testSlurm );
    CPPUNIT_TEST( testLSF );
    CPPUNIT_TEST( testLocal );
    CPPUNIT_TEST( testTitaneRun);
#endif
    CPPUNIT_TEST_SUITE_END();

public:
    //---------------------------------------------
    /** @name Constructor and Destructor
     **/
    //@{
    //! Default constructor
    TClusterTest();

    //! Default destructor
    virtual ~TClusterTest();

    void setUp();
    void tearDown();
    //@}

    //---------------------------------------------
    /** @name Unitary Tests of TCluster
     The platine test method
     The Local test method
     **/
    //@{
    //! Test the platine
    void testSlurm();
    //! Test the LSF
    /*
     LSB_MCPU_HOSTS=titane1516 8 titane1517 2
     peut-être plus facile à interpréter par
     LSB_HOSTS=titane1516 titane1516 titane1516 titane1516 titane1516 titane1516 titane1516 titane1516 titane1517 titane1517
     */
    void testLSF();
    //! Test the local server
    void testLocal();
    //! Test the batch mode on the platine supercomputer
    void testTitaneRun();
    //@}

private:

};

#endif  // CPPUNITEST_TCLUSTER_H
