//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2022 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
/*!
 \file   TestTCode.h
 \author Thierry Crestaux (CS)
 \date   30/07/2014
 
 \brief class TCode
 
 */
#ifndef CPPUNITEST_TCODE_H
#define CPPUNITEST_TCODE_H

#include <cppunit/extensions/HelperMacros.h>
//#include <cppunit/portability/CppUnitDeque.h>
#include <cppunit/Test.h>
#include <cppunit/TestFailure.h>
#include <cppunit/TestResultCollector.h>

// Uranie
#include "UExceptions.h"
#include "TCode.h"
#include "TOutputFileDataServer.h"
#include "TDataServer.h"
#include "TUniformDistribution.h"


using namespace URANIE::DataServer;
using namespace URANIE::Exceptions;
using namespace URANIE::Launcher;


/**

 * @class TCodeTest
 *
 * @brief Description of the class TCodeTest.
 *
 *  The class TCodeTest is the unit test class of the class TCode. 
 *  
 *
 */

class TCodeTest: public CPPUNIT_NS::TestFixture
{
    CPPUNIT_TEST_SUITE (TCodeTest);
    CPPUNIT_TEST (testGetTDataServer);
    // CPPUNIT_TEST (testGetTDataServer);
    CPPUNIT_TEST_SUITE_END();

public:
    //---------------------------------------------
    /** @name Constructor and Destructor
     **/
    //@{
    //! Default constructor
    TCodeTest();

    //! Default destructor
    virtual ~TCodeTest();

    void setUp();
    void tearDown();
    //@}

    //---------------------------------------------
    /** @name Unit Tests
	The list of unit test
    **/
    void testGetTDataServer();

private:
   
    Bool_t _bLog;
    
    URANIE::DataServer::TDataServer *_tdsFlowrate;
    URANIE::Launcher::TOutputFileDataServer *_foutDataServer;
    URANIE::Launcher::TCode *_codeFlowrate;

};

#endif  // CPPUNITEST_TCODE_H
