// --- C++ ---
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2013-2022 CEA/DES
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   UserFunctions.C
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2014-11-24
 
 \brief  undefined :-(
*/
void flowrateModel(double *x, double *y)
{
    Double_t drw = x[0], dr = x[1];
    Double_t dtu = x[2], dtl = x[3]; 
    Double_t dhu = x[4], dhl = x[5];
    Double_t dl = x[6], dkw = x[7];

    Double_t dnum = 2.0 * TMath::Pi() * dtu * (dhu - dhl);
    Double_t dlnronrw = TMath::Log(dr / drw);
    Double_t dden =
            dlnronrw
                    * (1.0 + (2.0 * dl * dtu) / (dlnronrw * drw * drw * dkw)
                            + dtu / dtl);

    y[0] = dnum / dden;
}

//! Sum function; adds the two first values of x in y
void fSum(double *x, double *y)
{
    y[0] = x[0] + x[1];
}

//! Product function; multiplies the two first values of x in y
void fProd(double *x, double *y)
{
    y[0] = x[0] * x[1];
}


