//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision$
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   multitype.cxx
 \author Jean-Baptiste Blanchard <jean-baptiste.blanchard@©ea.fr>
 \date   mar jun 01 16:00:00 2020
 
 \brief  "Pseudo" Code \b created to play with blank both in input key and output key files

 $Revision$
 $State$
 $Date$

 \par Revision
 \li JBB 2020-06-01
 Creation
 \endverbatim
 */

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <iostream>     // for I/O
#include <fstream>      // for file I/O
#include <sstream>   
#include <string>

using namespace std;

int main()
{

    double pressure=123456789;
    double density=123456789;
    //Getting the information
    fstream  afile;
    afile.open("withblank_input.dat", ios::in );
    string test;
    while ( afile >> test )
    {
        if (test == "=" && pressure==123456789)
            afile >> pressure;
        else if (test == "=" && density==123456789 )
        {
            afile >> density;
            break;
        }        
    }

    afile.close();

    double outpressure=pressure *2;
    double outdensity=density *3;

    //Write file
    ofstream out; stringstream sstr; sstr.precision(13); sstr.str("");
    //DataServer Output
    out.open("withblank_output.dat");
    sstr << "\nTest doubling.water model.brewery pit pressure = " << outpressure << " \n\n";
    sstr << "\n Bla Bla Bla \n\n";
    sstr << "\nChocolat doubling.residual brew density model.factor for glass = " << outdensity << " \n\n";
    out << sstr.str(); sstr.str("");
    out.close();
    
}
