#include "TMath.h"

void ModelPasture(Double_t *x, Double_t *y)
{
  Double_t theta1=69.95, theta2=61.68, theta3=-9.209, theta4=2.378;
  
  y[0] = theta1;
  y[0] -= theta2* TMath::Exp( -1.0 * TMath::Exp( theta3 + theta4 * TMath::Log(x[0])));
}

void dataserverLoadASCIIFilePasture()
{
      
  TCanvas *C = new TCanvas("mycanvas","mycanvas",1);

  TDataServer* tds = new TDataServer();
  tds->fileDataRead("pasture.dat");
    
  tds->getTuple()->SetMarkerStyle(8);
  tds->getTuple()->SetMarkerSize(1.5);
  tds->draw("yield:time");
  
  TLauncherFunction *tlf = new TLauncherFunction(tds, ModelPasture,"time","yhat");
  tlf->run();
    
  tds->getTuple()->SetMarkerColor(kBlue);
  tds->getTuple()->SetLineColor(kBlue);
  
  tds->draw("yhat:time","","lpsame");

  TDataServer *tds2 = new TDataServer();
  tds2->addAttribute( new TUniformDistribution("time2",9, 80));
    
  TSampling *tsamp = new TSampling(tds2, "lhs", 1000);
  tsamp->generateSample();
      
  tds2->getTuple()->SetMarkerColor(kGreen);
  tds2->getTuple()->SetLineColor(kGreen);
  tlf = new TLauncherFunction(tds2, ModelPasture,"","yhat2");
  tlf->run();
    

  tds2->draw("yhat2:time2","","psame");
  tds->draw("yhat:time","","lpsame");

  gPad->SaveAs("pasture.png");
    
}