{
  // Read the database
  TDataServer * tdsPCA = new TDataServer("tdsPCA", "my TDS");
  tdsPCA->fileDataRead("Notes.dat");

  // Create the PCA object precising the variables of interest
  TPCA * tpca = new TPCA(tdsPCA, "Maths:Physics:French:Latin:Music");
  tpca->compute();

  bool graphical=true; // do graphs
  bool dumponscreen=true; //or dumping results  
  bool showcoordinate=false; // show the coordinate of the points while dumping results

  if(graphical)
  {
  
      // Draw all point in PCA planes
      TCanvas *cPCA = new TCanvas("cpca", "PCA",800,800);
      TPad *apad1 = new TPad("apad1","apad1",0, 0.03, 1, 1); apad1->Draw(); apad1->cd();
      apad1->Divide(2,2);
      apad1->cd(1); tpca->drawPCA(1,2,"Pupil");
      apad1->cd(3); tpca->drawPCA(1,3,"Pupil");
      apad1->cd(4); tpca->drawPCA(2,3,"Pupil");

      // Draw all variable weight in PC definition  
      TCanvas *cLoading = new TCanvas("cLoading", "Loading Plot",800,800);
      TPad *apad2 = new TPad("apad2","apad2",0, 0.03, 1, 1); apad2->Draw(); apad2->cd();
      apad2->Divide(2,2);
      apad2->cd(1); tpca->drawLoading(1,2);
      apad2->cd(3); tpca->drawLoading(1,3);
      apad2->cd(4); tpca->drawLoading(2,3);

      // Draw the eigen values in different normalisation
      TCanvas *c = new TCanvas("cEigenValues", "Eigen Values Plot",1100,500);
      TPad *apad3 = new TPad("apad3","apad3",0, 0.03, 1, 1); apad3->Draw(); apad3->cd();
      apad3->Divide(3,1);
      TNtupleD *ntd = tpca->getResultNtupleD();
      apad3->cd(1); ntd->Draw("eigen:i","","lp");
      apad3->cd(2); ntd->Draw("eigen_pct:i","","lp"); gPad->SetGrid();
      apad3->cd(3); ntd->Draw("sum_eigen_pct:i","","lp"); gPad->SetGrid();
    
  }
  
  if(dumponscreen)
  {
      
      int nPCused=5; // 3 to see only the meaningful ones
      TString PCname="", Cosname="", Contrname="", Variable="Pupil";
      for (unsigned int iatt=1; iatt<=nPCused; iatt++)
      {
          PCname+=Form("PC_%d",iatt)+((iatt!=nPCused)?TString(":"):TString(""));
          Cosname+=Form("cosca_%d",iatt)+((iatt!=nPCused)?TString(":"):TString(""));
          Contrname+=Form("contr_%d",iatt)+((iatt!=nPCused)?TString(":"):TString(""));
      }

      cout<<endl<<"========= EigenValues ====================="<<endl;
      tpca->getResultNtupleD()->Scan("*");

      if(showcoordinate)
      {
          cout<<endl<<"========= EigenVectors ====================="<<endl;
          tpca->_matEigenVectors.Print();

          cout<<endl<<"========= New Coordinates ====================="<<endl;
          tdsPCA->scan( (Variable+":"+PCname).Data() );
      }
      
  
      TDSNtupleD *varRes  = tpca->getVariableResultNtupleD();
      cout<<endl<<"=============== Looking at variables: Quality of representation ====================="<<endl;
      varRes->Scan(("Variable:"+Cosname).Data());

      cout<<endl<<"==================== Looking at variables: Contribution to axis ====================="<<endl;
      varRes->Scan(("Variable:"+Contrname).Data());

      cout<<endl<<"================== Looking at events:  Quality of representation ===================="<<endl;
      tdsPCA->scan((Variable+":"+Cosname).Data());

      cout<<endl<<"===================== Looking at events: Contribution to axis ======================="<<endl;
      tdsPCA->scan((Variable+":"+Contrname).Data());

   }
}