{
  // OS abstraction
  string which_levele =
    string(gSystem->GetBuildArch()) == "win32" ? "where levele" : "which levele";

  //Exit if levele not found
  if(gSystem->Exec(which_levele.c_str()))
    exit(-1);

  //Create DataServer and add input attributes
  TDataServer *tds1 = new TDataServer("tds1", "levelE usecase");
  tds1->addAttribute( new TUniformDistribution("t",100,1000) );
  tds1->addAttribute( new TLogUniformDistribution("kl",0.001,0.01) );
  tds1->addAttribute( new TLogUniformDistribution("kc",0.000001,0.00001) );
  tds1->addAttribute( new TLogUniformDistribution("v1",0.001,0.1) );
  tds1->addAttribute( new TUniformDistribution("l1",100,500) );
  tds1->addAttribute( new TUniformDistribution("r1",1,5) );
  tds1->addAttribute( new TUniformDistribution("rc1",3,30) );
  tds1->addAttribute( new TLogUniformDistribution("v2",0.01,0.1) );
  tds1->addAttribute( new TUniformDistribution("l2",50,200) );
  tds1->addAttribute( new TUniformDistribution("r2",1,5) );
  tds1->addAttribute( new TUniformDistribution("rc2",3,30) );
  tds1->addAttribute( new TLogUniformDistribution("w",100000,10000000) );

  //Tell the code where to find attribute value in input file
  TString sJDD = "levelE_input_with_values_rows.in";
  tds1->getAttribute("t")->setFileKey(sJDD, "", "%e",TAttributeFileKey::kNewRow);
  tds1->getAttribute("kl")->setFileKey(sJDD,"", "%e",TAttributeFileKey::kNewRow);
  tds1->getAttribute("kc")->setFileKey(sJDD, "", "%e",TAttributeFileKey::kNewRow);
  tds1->getAttribute("v1")->setFileKey(sJDD, "", "%e",TAttributeFileKey::kNewRow);
  tds1->getAttribute("l1")->setFileKey(sJDD, "", "%e",TAttributeFileKey::kNewRow);
  tds1->getAttribute("r1")->setFileKey(sJDD, "", "%e",TAttributeFileKey::kNewRow);
  tds1->getAttribute("rc1")->setFileKey(sJDD, "", "%e",TAttributeFileKey::kNewRow);
  tds1->getAttribute("v2")->setFileKey(sJDD, "", "%e",TAttributeFileKey::kNewRow);
  tds1->getAttribute("l2")->setFileKey(sJDD, "", "%e",TAttributeFileKey::kNewRow);
  tds1->getAttribute("r2")->setFileKey(sJDD, "", "%e",TAttributeFileKey::kNewRow);
  tds1->getAttribute("rc2")->setFileKey(sJDD, "", "%e",TAttributeFileKey::kNewRow);
  tds1->getAttribute("w")->setFileKey(sJDD, "", "%e",TAttributeFileKey::kNewRow);

  // Create DOE
  Int_t ns = 100;
  TSampling *samp = new TSampling(tds1, "lhs", ns);
  samp->generateSample();  

  //How to read ouput files
  TOutputFileRow *_fout = new URANIE::Launcher::TOutputFileRow("_output_levelE_withRow_.dat");
  _fout->addAttribute(new TAttribute("tps",TAttribute::kVector));
  _fout->addAttribute(new TAttribute("y",TAttribute::kVector));
  _fout->addAttribute(new TAttribute("z",TAttribute::kVector));

  //Creation of TCode
  TCode *tc1 = new URANIE::Launcher::TCode(tds1, "levele 2> /dev/null");
  tc1->addOutputFile( _fout );

  //Run the code
  TLauncher *tl1 = new URANIE::Launcher::TLauncher(tds1, tc1);
  tl1->run();

  //Draw the results
  TCanvas *Can = new TCanvas("Can","Can",1);
  Can->SetGrid(); Can->SetLogx();

  double mean[26], stand[26];
  tds1->computeStatistic("y");
  for(unsigned int i=0; i<26; i++)
    {
      mean[i] = tds1->getAttribute("y")->getMean(i);
      stand[i] = tds1->getAttribute("y")->getStd(i);
    }
  
  double tps[26]={20000,30000,40000,50000,60000,70000,80000,90000,100000, 200000,300000,400000,500000,600000,700000,800000,900000, 1e+06,2e+06,3e+06,4e+06,5e+06,6e+06,7e+06,8e+06,9e+06};
  TGraphErrors *gr = new TGraphErrors(26,tps,mean,0,stand);
  gr->Draw("A*");
  gr->SetTitle("");
  gr->GetXaxis()->SetTitle("Time"); gr->GetYaxis()->SetTitle("<y>");   
  
}
  