{
  //Create dataserver with the seed attribute
  TDataServer *tds = new TDataServer("foo","pouet");
  tds->addAttribute( new TUniformDistribution("seed",0,100000));
  tds->getAttribute("seed")->setFileKey("multitype_input.dat","", "%e",TAttributeFileKey::kNewRow);

  //Create DOE
  TSampling *tsam = new TSampling(tds,"lhs",100);
  tsam->generateSample();

  //Precise output and create Code
  TOutputFileXML *out = new TOutputFileXML("_output_multitype_mt_.xml");
  out->addAttribute(new TAttribute("w1",TAttribute::kString), "/multitypeMT/w1/@value", TAttributeFileKey::kXMLAttribute );
  out->addAttribute(new TAttribute("w2",TAttribute::kString), "/multitypeMT/w2/@value", TAttributeFileKey::kXMLAttribute );
  out->addAttribute(new TAttribute("v1",TAttribute::kVector), "/multitypeMT/v1/values", TAttributeFileKey::kXMLField );
  out->addAttribute(new TAttribute("v2",TAttribute::kVector), "/multitypeMT/v2/values", TAttributeFileKey::kXMLField );
  out->addAttribute(new TAttribute("f1"),                     "/multitypeMT/f1/@value", TAttributeFileKey::kXMLAttribute );
  
  TCode *myc = new URANIE::Launcher::TCode(tds, "multitype -mtXML");
  myc->addOutputFile( out );

  //Create TLauncher and run it
  TLauncher *tlau = new URANIE::Launcher::TLauncher(tds, myc);
  tlau->run();

  //Produce control plot
  TCanvas *Can = new TCanvas("Can","Can",10,10,1000,800);
  TPad *pad = new TPad("pad","pad",0, 0.03, 1, 1); pad->Draw(); pad->cd();
  tds->drawPairs("w1:v1:v2:f1:w2");
  
}
  