"""
Example of database function launching
"""
from rootlogon import ROOT, DataServer, Launcher

# Create a DataServer.TDataServer
tds = DataServer.TDataServer()
# Load the data set in the DataServer
tds.fileDataRead("flowrateUniformDesign.dat")

# Load the function in the UserFunction macros file
ROOT.gROOT.LoadMacro("UserFunctions.C")

# Create a TLauncherFunction from a TDataServer and an analytical function
# Rename the outpout attribute "ymod"
tlf = Launcher.TLauncherFunction(tds, "flowrateModel", "", "ymod")
# Evaluate the function on all the points in the Design Of Experiments (DoE)
tlf.run()

# Graph
Canvas = ROOT.TCanvas("c1", "Graph for the Macro loadASCIIFile",
                      5, 64, 1270, 667)
pad = ROOT.TPad("pad", "pad", 0, 0.03, 1, 1)
pad.Draw()
pad.Divide(2, 4)
pad.cd(1)
tds.draw("ymod:rw")
pad.cd(2)
tds.draw("ymod:r")
pad.cd(3)
tds.draw("ymod:tu")
pad.cd(4)
tds.draw("ymod:tl")
pad.cd(5)
tds.draw("ymod:hu")
pad.cd(6)
tds.draw("ymod:hl")
pad.cd(7)
tds.draw("ymod:l")
pad.cd(8)
tds.draw("ymod:kw")
