{       
  // Create a TDataServer
  // Load a database in an ASCII file
  TDataServer * tdsu = new TDataServer("tdsu","tds u");
  tdsu->fileDataRead("flowrate_sampler_launcher_500.dat");

  //Create database
  tdsu->exportData("_flowrate_sampler_launcher_app_.dat", "","tdsFlowrate__n__iter__<=300");
  tdsu->exportData("_flowrate_sampler_launcher_val_.dat", "","tdsFlowrate__n__iter__>300");

  TDataServer * tds = new TDataServer("tdsFlowrate", "tds for flowrate");
  tds->fileDataRead("_flowrate_sampler_launcher_app_.dat");
  
  TCanvas *c = new TCanvas("c1", "Graph for the Macro modeler",5,64,1270,667);
  // Buils a surrogate model (Artificial Neural Networks) from the DataBase
  TANNModeler* tann = new TANNModeler(tds, "rw:r:tu:tl:hu:hl:l:kw,3,yhat"); 
  tann->setFcnTol(1e-5);
  //tann->setLog();
  tann->train(3, 2, "test");
  
  tann->exportFunction("pmmlc++","uranie_ann_flowrate","ANNflowrate");
    
  gROOT->LoadMacro("uranie_ann_flowrate.C");

  TDataServer * tdsv = new TDataServer();
  tdsv->fileDataRead("_flowrate_sampler_launcher_val_.dat");

  cout << tdsv->getNPatterns() << endl;

  // evaluate the surrogate model on the database
  TLauncherFunction * tlf = new TLauncherFunction(tdsv, "ANNflowrate", "rw:r:tu:tl:hu:hl:l:kw", "yann");
  tlf->run();    
    
  tdsv->startViewer();
  
  tdsv->Draw("yann:yhat");
  //  tdsv->draw("yhat");
     
}
