"""
Example of linear regression on flowrate
"""
from rootlogon import DataServer, Modeler

tds = DataServer.TDataServer()
tds.fileDataRead("flowrate_sampler_launcher_500.dat")  # Read the database

# Create the linear regression
tlin = Modeler.TLinearRegression(tds, "rw:r:tu:tl:hu:hl:l:kw",
                                 "yhat", "DummyForPython")
tlin.estimate()  # Estimate the parameters

print(" ** R2[%g] R2A[%g] QR2[%g]" % (tlin.getR2(), tlin.getR2Adjusted(),
                                      tlin.getQ2()))

tlin.exportFunction("c++", "myASCIIFile", "myFunction")
