{
  // Load observations
  TDataServer *tdsObs = new TDataServer("tdsObs","");
  tdsObs->fileDataRead("utf_4D_train.dat");

  // Construct the GPBuilder        
  TGPBuilder *gpb = new TGPBuilder(tdsObs, "x1:x2:x3:x4", "y", "matern3/2");

  // Search for the optimal hyper-parameters
  gpb->findOptimalParameters("ML", 100, "neldermead", 500);
  
  // Create a new observation
  Double_t newObs[5] = {7.547605e-01, 8.763968e-01, 1.255390e-01, 6.370434e-01, 1.189220e+00};
      
  // Add the new observation to tdsObs
  Double_t newLine[6];
  newLine[0] = tdsObs->getNPatterns()+1; // Index of the new observation
  newLine[1] = newObs[0];
  newLine[2] = newObs[1];
  newLine[3] = newObs[2];
  newLine[4] = newObs[3];
  newLine[5] = newObs[4];
  
  tdsObs->getTuple()->Fill(newLine);

  // Update the GP Builder
  gpb->updateObservations();
  
  // Search for the new optimal hyper-parameters, starting from their current values 
  gpb->findOptimalParameters("ML", 0, "bobyqa", 500, kFALSE);

  // Create the model
  TKriging *krig = gpb->buildGP();
      
  // Display model information
  krig->printLog();                                
  
  }