{
  // Load the function
  gROOT->LoadMacro("UserFunctions.C");
  
  // Les variables de l'etude
  TAttribute *x = new TAttribute("x", -1.5, 1.5);
  x->setDefaultValue(-1.2);
  x->setStepValue(0.01);

  TAttribute *y = new TAttribute("y", -1.5,1.5);
  y->setDefaultValue(1.);
  y->setStepValue(0.01);
  
  TDataServer *tdsRosenbrock = new TDataServer("tdsRosenbrock", "Optimize Code externe Rosenbrock via TDataServer");
  tdsRosenbrock->addAttribute(x);
  tdsRosenbrock->addAttribute(y);

  tdsRosenbrock->addAttribute("xshift","x-0.1");
  tdsRosenbrock->addAttribute("yshift","y+0.2");
    
  // Graph
  TCanvas  *Canvas = new TCanvas("c1", "Graph for the Macro optimizeFunctionRosenbrockNewInputOutput",5,64,1270,667);
  
  // Create an TOptimizer object from TDataServer and an anlystical function
  TOptimizer * topt = new TOptimizer(tdsRosenbrock, "rosenbrock","xshift:yshift","out");
  topt->addOutputVariable("out+1:out*out:out*3");
  topt->selectCost("out+1");
  // topt->setMethod(TOptimizer::kSimplex);
  // topt->setTolerance(1e-5);
  // topt->setPrintLevel(5);
  // topt->setMaxIterations(3);
  // topt->setMaxFunctionCalls(10);
  topt->optimize("same");
  tdsRosenbrock->exportData("_tds_rosenbrock_.dat");
    
}
