{

  TAttribute *rw = new TAttribute("rw");
  TAttribute *r = new TAttribute("r");
  TAttribute *tu = new TAttribute("tu");
  TAttribute *tl = new TAttribute("tl");
  TAttribute *hu = new TAttribute("hu");
  TAttribute *hl = new TAttribute("hl");
  TAttribute *l = new TAttribute("l");
  TAttribute *kw = new TAttribute("kw");

  // Create the output attribute
  TAttribute *yhat = new TAttribute("yhat");
  TAttribute *d = new TAttribute("d");
  
  // Set the reference input file and the key for each input attributes
  TFlatScript fin("flowrate_input_with_values_rows.in");
  fin.setInputs(8, rw, r, tu, tl, hu, hl, l, kw);

  // The output file of the code
  TFlatResult fout("_output_flowrate_withRow_.dat");
  fout.setOutputs(2, yhat, d);// Passing the attributes to the output file

  // Constructing the code
  TCodeEval mycode( "flowrate -s -r" );    
  mycode.setOldTmpDir();
  mycode.addInputFile(&fin); // Adding the input file
  mycode.addOutputFile(&fout); // Adding the output file

  // Fix the number of threads
  int nthread = 3;
  // Create the Threaded runner
  TThreadedRun run(&mycode, nthread);
  run.startSlave(); // Start the master 
  if (run.onMaster())
  {
      // Create the TDataServer
      TDataServer *tds = new TDataServer("foo","test");
      mycode.addAllInputs(tds);
      tds->fileDataRead("flowrateUniformDesign.dat", kFALSE, kTRUE);

      TLauncher2 lanceur(tds, &run);

      // resolution
      lanceur.solverLoop();
      run.stopSlave(); // Stop the slaves (necessary even for a sequential)
  
      // Draw the result
      TCanvas *can = new TCanvas("pouet","foo",1);
      tds->Draw("yhat:rw","","colZ");  }  
  
}
