{

    // Definition of the reference dataserver
    TDataServer *tdsMulti = new TDataServer("tdsMulti", "Objectives values");
    tdsMulti->fileDataRead("rosenbrock_ref.dat");
    TString sinputfile ="input_rosenbrock_with_keys.dat";
    tdsMulti->getAttribute("x1")->setFileKey(sinputfile, "x");
    tdsMulti->getAttribute("x2")->setFileKey(sinputfile, "y");

    // Definition of the output file of the code
    TOutputFileRow *fout = new TOutputFileRow("_output_rosenbrock_with_values_rows_.dat");
    fout->addAttribute(new TAttribute("yhat"), 3); 
    // OS abstraction
    string to_null =
        string(gSystem->GetBuildArch()) == "win32" ? " > NUL" : " >> /dev/null";
    // Definition of the code
    TCode *mycode = new TCode(tdsMulti, "rosenbrock -k" + to_null);
    mycode->addOutputFile(fout); 
    // Launcher on the TDS Ref
    TLauncher * tl = new TLauncher(tdsMulti, mycode);
    tl->setDrawProgressBar(kFALSE);
    tl->run("nointermediatesaved"); 
    tdsMulti->exportData("_rosenbrock_multi_.dat","x1:x2:yhat");
}
