
void sensitivityMorrisFunctionFlowrate(Int_t nk = 5)
{
      
  gROOT->LoadMacro("UserFunctions.C");

  // Define the DataServer
  TDataServer *tds = new TDataServer("tdsflowreate", "DataBase flowreate");
  tds->addAttribute( new TUniformDistribution("rw", 0.05, 0.15));
  tds->addAttribute( new TUniformDistribution("r", 100.0, 50000.0));
  tds->addAttribute( new TUniformDistribution("tu", 63070.0, 115600.0));
  tds->addAttribute( new TUniformDistribution("tl", 63.1, 116.0));
  tds->addAttribute( new TUniformDistribution("hu", 990.0, 1110.0));
  tds->addAttribute( new TUniformDistribution("hl", 700.0, 820.0));
  tds->addAttribute( new TUniformDistribution("l", 1120.0, 1680.0));
  tds->addAttribute( new TUniformDistribution("kw", 9855.0, 12045.0));
    
  Int_t nreplique = 3;
  Int_t nlevel = 10;
  TMorris * scmo = new TMorris(tds, "flowrateModel", nreplique, nlevel); 
  scmo->setDrawProgressBar(kFALSE);
  scmo->generateSample();
    
  tds->exportData("_morris_sampling_.dat");
  scmo->computeIndexes();
    
  tds->exportData("_morris_launching_.dat");

  TTree *ntresu = scmo->getMorrisResults();
  ntresu->Scan("*");
     
  // Graph
  TCanvas  *cc = new TCanvas("c1", "Graph for the Macro sensitivityMorrisFunctionFlowrate",5,64,1270,667);
  TPad *pad = new TPad("pad","pad",0, 0.03, 1, 1); pad->Draw();
  pad->Divide(2);
  pad->cd(1);
  scmo->drawSample("", -1,"nonewcanv");
  pad->cd(2);
  scmo->drawIndexes("mustar,nonewcanv");
   
}