{

  gROOT->LoadMacro("UserFunctions.C");
   
  // Define the DataServer
  TDataServer *tds = new TDataServer("tdsflowreate", "DataBase flowreate");
  tds->addAttribute( new TUniformDistribution("rw", 0.05, 0.15));
  tds->addAttribute( new TUniformDistribution("r", 100.0, 50000.0));
  tds->addAttribute( new TUniformDistribution("tu", 63070.0, 115600.0));
  tds->addAttribute( new TUniformDistribution("tl", 63.1, 116.0));
  tds->addAttribute( new TUniformDistribution("hu", 990.0, 1110.0));
  tds->addAttribute( new TUniformDistribution("hl", 700.0, 820.0));
  tds->addAttribute( new TUniformDistribution("l", 1120.0, 1680.0));
  tds->addAttribute( new TUniformDistribution("kw", 9855.0, 12045.0));
  
  Int_t ns = 100000;
  TSobol * tsobol = new TSobol(tds, "flowrateModel", ns, "rw:r:tu:tl:hu:hl:l:kw", "flowrateModel", "pouet"); 
  tsobol->setDrawProgressBar(kFALSE);
  tsobol->computeIndexes();

  tsobol->getResultTuple()->Scan("*","Algo==\"--first--\" || Algo==\"--total--\"");
      
  TCanvas *cc = new TCanvas("c1", "histgramme",5,64,1270,667);
  TPad *pad = new TPad("pad","pad",0, 0.03, 1, 1); pad->Draw();
  pad->Divide(2,1);
  pad->cd(1);
  tsobol->drawIndexes("Flowrate", "", "nonewcanv,hist,all");
    
  pad->cd(2);
  tsobol->drawIndexes("Flowrate", "", "nonewcanv,pie,first");
    
  gSystem->Rename("_sobol_launching_.dat","ref_sobol_launching_.dat");
  tds->exportData("_onlyMandN_sobol_launching_.dat","rw:r:tu:tl:hu:hl:l:kw:flowrateModel","sobol__n__iter__tdsflowreate < 100");
}