{

  gROOT->LoadMacro("UserFunctions.C");
   
  // Define the attributes
  TUniformDistribution rw("rw", 0.05, 0.15);
  TUniformDistribution r("r", 100.0, 50000.0);
  TUniformDistribution tu("tu", 63070.0, 115600.0);
  TUniformDistribution tl("tl", 63.1, 116.0);
  TUniformDistribution hu("hu", 990.0, 1110.0);
  TUniformDistribution hl("hl", 700.0, 820.0);
  TUniformDistribution l("l", 1120.0, 1680.0);
  TUniformDistribution kw("kw", 9855.0, 12045.0);

  // Create the evaluator
  TCIntEval code("flowrateModel");
  // Create output attribute
  TAttribute yout("flowrateModel");
  // Provide input/output attributes to the assessor
  code.setInputs(8, &rw, &r, &tu, &tl, &hu, &hl, &l, &kw);
  code.setOutputs(1, &yout);

  TSequentialRun run(&code); // To be replaced to distribute the computation
  run.startSlave();
  if( run.onMaster())
  {
     // Create the dataserver
     TDataServer *tds = new TDataServer("sobol", "foo bar pouet chocolat");
     tds->addAttribute(&rw);
     tds->addAttribute(&r);
     tds->addAttribute(&tu);
     tds->addAttribute(&tl);
     tds->addAttribute(&hu);
     tds->addAttribute(&hl);
     tds->addAttribute(&l);
     tds->addAttribute(&kw);
     
     // Create the sobol object     
     Int_t ns = 100000;
     TSobol * tsobol = new TSobol(tds, &run, ns); 
     tsobol->setDrawProgressBar(kFALSE);
     tsobol->computeIndexes();
       
     if ( 1 ) {
       TCanvas *cc = new TCanvas("c1", "histgramme",5,64,1270,667);
       TPad *pad = new TPad("pad","pad",0, 0.03, 1, 1); pad->Draw();
       pad->Divide(2,1);
       pad->cd(1);
       tsobol->drawIndexes("Flowrate", "", "nonewcanv,hist,all");
       
       pad->cd(2);
       tsobol->drawIndexes("Flowrate", "", "nonewcanv,pie,first");
    
    }
  }
}