//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2022 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////

#ifndef CPPUNITEST_TRelativeLSDISTANCEFUNCTION_H
#define CPPUNITEST_TRelativeLSDISTANCEFUNCTION_H

// CppUnit
#include <cppunit/extensions/HelperMacros.h>
#include <cppunit/Test.h>

//URANIE
#include "TDataServer.h"
#include "TStandardDistanceFunction.h"

using namespace URANIE::DataServer;
using namespace URANIE::Calibration;

class TRelativeLSDistanceFunctionTest: public CPPUNIT_NS::TestFixture
{
    CPPUNIT_TEST_SUITE (TRelativeLSDistanceFunctionTest);

    CPPUNIT_TEST ( throwExceptionConstructor );
    CPPUNIT_TEST ( throwExceptionSetObservationCovMatrix );
    CPPUNIT_TEST ( throwExceptionSetVarWeights );
    CPPUNIT_TEST ( throwExceptionSetGaussianRandomNoise );
    CPPUNIT_TEST ( throwExceptionGetObservation );

    CPPUNIT_TEST_SUITE_END();

public:
    //---------------------------------------------
    /** @name Constructor and Destructor
     **/
    //@{
    //! Default constructor
    TRelativeLSDistanceFunctionTest();

    //! Default destructor
    virtual ~TRelativeLSDistanceFunctionTest();
    //@}

    //---------------------------------------------
    /** @name SetUp and internals methods
     **/
    //@{
    void setUp();
    void tearDown();

    //@}
    //---------------------------------------------
    /** @name Unit Tests
     The list of unit test
     **/
    //@{
    void throwExceptionConstructor();
    void throwExceptionSetObservationCovMatrix();
    void throwExceptionSetVarWeights();
    void throwExceptionSetGaussianRandomNoise();
    void throwExceptionGetObservation();
    //@}

private:
    TDataServer *_tdsEval;
    TDataServer *_tdsRef;
    TRelativeLSDistanceFunction *_tdf;
};

#endif

