/*//////////////////////////////////////////////////////////////
 // Copyright (C) 2013-2022 CEA/DES
 //
 // This program is free software: you can redistribute it and/or modify
 // it under the terms of the GNU Lesser General Public License as published
 // by the Free Software Foundation, either version 3 of the License, or any
 // later version.
 //
 // This program is distributed in the hope that it will be useful,
 // but WITHOUT ANY WARRANTY; without even the implied warranty of
 // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 // GNU Lesser General Public License for more details.
 //
 // You should have received a copy of the GNU Lesser General Public License
 // along with this program. If not, see <http://www.gnu.org/licenses/>.
 //////////////////////////////////////////////////////////////
 //////////////////////////////////////////////////////////////
 // $Id$
 // $Author$
 // $Date$
 // $Revision$
 // $State$
 //////////////////////////////////////////////////////////////*/
/*!
 \file   chebev.c
 \author Jean-Marc Martinez <jean-marc.martinez@cea.fr>
 \date   2012/07/19 15:38:00

 \brief
 */
/* -- ngi: modifications du 25/10/2012 --
 ** - le test d'appartenance de x a l'interval ]a,b[ a ete commente en raison de la disparition de 
 **   la fonction nrerror. Ce test doit donc etre effectue dans la fonction appelante.
 */
double chebev(double a, double b, double c[], int m, double x)
{
    double d = 0.0, dd = 0.0, sv, y, y2;
    int j;

    /*    if ((x-a)*(x-b) > 0.0) nrerror("x not in range in routine chebev");*/
    y2 = 2.0 * (y = (2.0 * x - a - b) / (b - a));
    for (j = m - 1; j >= 1; j--)
    {
        sv = d;
        d = y2 * d - dd + c[j];
        dd = sv;
    }
    return y * d - dd + 0.5 * c[0];
}

