//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2022 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TCorrelationFunction.cxx
 \author Nicolas Gilardi <nicolas.gilardi@cea.fr>
 \date   

 \brief Implementation of the class  URANIE::Modeler::TCorrelationFunction

 */

#include <iostream>
//// ROOT
#include "TDecompSVD.h"
#include "TLeaf.h"

//// URANIE
#include "TCorrelationFunction.h"
#include "TAttribute.h"

using std::cout;
using std::endl;
using namespace URANIE::DataServer;

ClassImp (URANIE::Modeler::TCorrelationFunction)

namespace URANIE
{
    namespace Modeler
    {
        // -----------------------------------------------------------------------
        //  Constructors
        // -----------------------------------------------------------------------
        TCorrelationFunction::TCorrelationFunction() :
        _blog(kFALSE)
        {
            // --ngi: anything to do ? --
        }
        
        // -----------------------------------------------------------------------
        //  Destructor
        // -----------------------------------------------------------------------
        
        TCorrelationFunction::~TCorrelationFunction()
        {
            if (_blog)
                cout << "detruit TCorrelationFunction" << endl;
        }
        
        // -----------------------------------------------------------------------
        //  Log
        // -----------------------------------------------------------------------
        void TCorrelationFunction::printLog(Option_t *option)
        {
            cout << "*******************************" << endl;
            cout << " ** TCorrelationFunction::printLog[" << option << "]" << endl;
            cout << "*******************************" << endl;
        }
    
    } // Fin du namespace Modeler
} // Fin du namespace URANIE

