//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2022 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////

/** ****************************************************** **
                    Kernels (GPU)
 ** ****************************************************** **/

#ifndef CPU_PROCESSING_ONLY

  #ifndef __NN_KERNELS_GPU_INCLUDE__
  #define __NN_KERNELS_GPU_INCLUDE__

    namespace NeuralNetworkLevenbergMarquardt
    {
      namespace GPU
      {    
        namespace Wrappers
        {
          void kIdentityMatrix( dim3 numBlocks, dim3 threadsPerBlock,
                                const int N, Real* id );
          void kNormalizeSamples( dim3 numBlocks, dim3 threadsPerBlock,
                                                         const int N, const NeuronType T, Real* teacher,
                                                         const Real min, const Real max );
          void kActivationFunction( dim3 numBlocks, dim3 threadsPerBlock,
                                                           const int NK, const int N, const NeuronType T,
                                                           Real* values );
          void kJacobianElement( const int M, const int K, const int N,
                                  const NeuronType T,
                                                        const Real* hiddenOutput, const Real* weightsOutput,
                                                        const Real* inputValues, Real* jacobian );
        } // namespace Wrappers
      
      } // namespace GPU

    } // namespace NeuralNetworkLevenbergMarquardt

  #endif // #ifndef __NN_KERNELS_GPU_INCLUDE__

#endif // #ifndef CPU_PROCESSING_ONLY
