//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2022 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////

#ifndef __NN_TESTING_H__
#define __NN_TESTING_H__

#include "multilayerperceptron.h"

namespace NeuralNetworkLevenbergMarquardt
{
  namespace Testing
  {
    void testWithXOR( const Real precision, const size_t nbRuns = 1, const size_t nbMaxIter = 20 );
    void testWithRosenbrock( const size_t nbSamples, const Real precision, const size_t nbRuns = 1, const size_t nbMaxIter = 5000 );
    void testWithRefFileRosenbrock( const std::string& strFileIn, const std::string& strFileOut, const Real precision, const size_t nbMaxIter = 5000 );
    void testCaseANDRA( const std::string& directory, const std::string& strFileIn, const std::string& outputPrefix,
                        const Real precision, const size_t nbMaxIter = 5000, const size_t nbTrainings = 1, const size_t nbBatchRuns = 1 );
  }
}

#endif /* __NN_TESTING_H__ */
