//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2022 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision$
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   nisp_ind.cpp
 \author Jean-Marc Martinez <jean-marc.martinez@cea.fr>
 \date   2011/04/07 14:33:00

 \brief
 */
#include <iostream>
#include <sstream>
#include <fstream>
#include <string>

using namespace std;

#include "nisp_util.h"

static int *IndiceMultiple;
static int nx, no, kk;

void IndiceMultipleEvalRec(int r, int **indmul)
{
    int i, i0;
    for (i0 = no, i = 1; i < r; i++)
        i0 -= IndiceMultiple[i - 1];
    for (IndiceMultiple[r - 1] = i0; IndiceMultiple[r - 1] >= 0;
            IndiceMultiple[r - 1] = IndiceMultiple[r - 1] - 1)
    {
        if ((r + 1) < nx)
            IndiceMultipleEvalRec(r + 1, indmul);
        else
        {
            for (IndiceMultiple[nx - 1] = no, i = 1; i < nx; i++)
                IndiceMultiple[nx - 1] -= IndiceMultiple[i - 1];
            for (i = 1; i <= nx; i++)
                indmul[kk][i] = IndiceMultiple[i - 1];
            kk++;
        }
    }
}

int IndiceMultipleEval(int nnx, int noi, int nof, int **indmul)
{
    int i;
    kk = 0; /* kk = 0,1,...,p */
    nx = nnx;

    IndiceMultiple = new int[nx];

    if ((nx >= 1) && (noi >= 0) && (nof >= noi))
    {
        if (nx == 1)
        {
            for (i = noi; i <= nof; i++)
                indmul[kk++][1] = i;
        }
        else
        {
            for (no = noi; no <= nof; no++)
            {
                for (i = 1; i <= nx; i++)
                    IndiceMultiple[i - 1] = 0;
                IndiceMultipleEvalRec(1, indmul);
            }
        }
        delete[] IndiceMultiple;
        return (kk - 1);
    }
    else
    {
        ostringstream msg;
        msg << "Nisp(IndiceMultipleEval) : Error nx = " << nx << " noi = "
                << noi << " nof = " << nof << endl;
        NispOutPutMsg(msg.str(), 1);
        return (0);
    }
}

