//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2022 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision$
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   nisp_math.cpp
 \author Jean-Marc Martinez <jean-marc.martinez@cea.fr>
 \date   2011/04/07 14:33:00

 \brief
 */
 
#include "nisp_util.h" 
 
using namespace std;

int * ivector(int n)
{
    return (new int[n]);
}

int ** imatrix(int l, int c)
{
    int **a = new int *[l];
    for (int i = 0; i < l; i++)
        a[i] = new int[c];
    return (a);
}

void free_ivector(int * v)
{
    delete[] v;
}

void free_imatrix(int ** mat, int l)
{
    for (int i = 0; i < l; i++)
        delete[] mat[i];
    delete[] mat;
}

double * dvector(int n)
{
    return (new double[n]);
}

double ** dmatrix(int l, int c)
{
    double **a = new double *[l];
    for (int i = 0; i < l; i++)
        a[i] = new double[c];
    return (a);
}

void free_dvector(double * v)
{
    delete[] v;
}

void free_dmatrix(double ** mat, int l)
{
    for (int i = 0; i < l; i++)
        delete[] mat[i];
    delete[] mat;
}
