//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2022 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision$
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   nisp_msg.cpp
 \author Jean-Marc Martinez <jean-marc.martinez@cea.fr>
 \date   2011/04/07 14:33:00

 \brief
 */
#include <iostream>
#include <fstream>
#include <string>
#include <stdlib.h>

using namespace std;

static int Scilab = 0;

///////////////////////
// Gestion des messages
///////////////////////
void NispOutPutMsg(char * message, int error)
{
    streambuf *psbuf;
    streambuf *save_psbufcout;
    ofstream MyOutput;

    if (Scilab)
    {
        // Sauvegarde pour la sortie standard
        save_psbufcout = cout.rdbuf();
        /////////////////////////////////////
        // Acquerir la sortie de Scilab
        MyOutput.open("scilab.txt", ios::app);
        /////////////////////////////////////
        psbuf = MyOutput.rdbuf();
        // redirection vers la sortie de Scilab
        cout.rdbuf(psbuf);
    }

    else
    {
        cout << message;
        if (error)
            exit(1);
    }

    // On reconstitue le buffer de la sortie standard de cout car sinon �a plante !!
    if (Scilab)
    {
        cout.rdbuf(save_psbufcout);
        MyOutput.close();
    }
}

// pour les string : ecriture string -> char
void NispOutPutMsg(string str, int error)
{
    char * buffer = new char[str.size() + 1];
    for (unsigned int i = 0; i < str.size(); i++)
        buffer[i] = str[i];
    buffer[str.size()] = '\0';
    NispOutPutMsg(buffer, error);
    delete[] buffer;
}

