//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2022 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision$
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   nisp_util.h
 \author Jean-Marc Martinez <jean-marc.martinez@cea.fr>
 \date   2011/04/07 14:33:00

 \brief  Utilities
 */
#include "nisp_pc.h"
#ifdef WIN32
#include "libnisp_Export.h"
#else
#define libnisp_EXPORT
#endif

libnisp_EXPORT int * ivector(int n);
libnisp_EXPORT double * dvector(int n);
libnisp_EXPORT int ** imatrix(int l, int c);
libnisp_EXPORT double ** dmatrix(int l, int c);

libnisp_EXPORT void free_ivector(int * v);
libnisp_EXPORT void free_dvector(double * v);
libnisp_EXPORT void free_imatrix(int ** mat, int l);
libnisp_EXPORT void free_dmatrix(double ** mat, int l);

libnisp_EXPORT void InitSeed(int);
void NispOutPutMsg(char * str, int error);
void NispOutPutMsg(string str, int error);

// add msa
libnisp_EXPORT void WriteCodeSrc(PolynomialChaos * pc, ofstream & ficsrc, char *name);
libnisp_EXPORT void WriteIndiceMultiple(PolynomialChaos * pc, ofstream & ficsrc, char *name);
libnisp_EXPORT void WriteCoef(PolynomialChaos * pc, ofstream & ficsrc, char *name);
libnisp_EXPORT void WriteCodeHermite(ofstream & ficsrc, char *name);
libnisp_EXPORT void WriteCodeLegendre(ofstream & ficsrc, char *name);
libnisp_EXPORT void WriteCodeLaguerre(ofstream & ficsrc, char *name);
libnisp_EXPORT void WriteCodeJacobi(ofstream & ficsrc, char *name, double, double);


