void Dirichlet (Double_t *x, Double_t *y) {
  Double_t z, w, h;
  Int_t Dim = 4;
  Double_t Alpha[4];
  for (Int_t i=0; i < Dim; i++) Alpha[i] = 1. / (i + 1.);
  y[0] = 1.;
  for (Int_t i=0; i < Dim; i++) {
    z = TMath::Pi() * x[i];
    w = sqrt(2. * i + 2.);

    if (fabs(z) > 1.e-6) {
      h = (1. / w) * (TMath::Sin((2. * i + 3.) * z) / TMath::Sin(z) - 1.);
    } else h = w;
    y[0] = y[0] * (1. + Alpha[i] * h);
  }
}

