//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2022 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any 
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision 1.3 $
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   vzr_mono.c
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date    2008-03-28.11.56.40

 \brief classement specifique au monocritere
 */

#include <stdio.h>

#include "vzr_util.h"

/** fonction du protocole **/
static double rang_individu(void *truc, struct vizir *viz, struct vzrwork *wviz)
{
    return wviz->val[0];
}

static void rang_population(void *truc, struct vizir *viz)
{
    int i;
    for (i = 0; i < viz->N; i++)
        viz->pop_val[i][viz->rangdomi] = viz->pop_val[i][0];
}

static int elite(void *truc, struct vizir *viz)
{
    int ret;

    ret = 1;
    while (ret < viz->N
            && viz->pop_val[ret][viz->rangdomi]
                    <= viz->pop_val[0][viz->rangdomi])
        ret++;
    printf("%s\tfmin : %e, fmax : %e\n", viz->id,
            viz->pop_val[0][viz->rangdomi],
            viz->pop_val[viz->itaille - 1][viz->rangdomi]);
    return ret;
}

/** definition de l'instance de protocole **/

struct vzrclasse *vizir1_mono(void)
{
    static struct vzrclasse _mono =
    { (void *) NULL, 1, &rang_individu, &rang_population, &elite };
    return &_mono;
}

