//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2022 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any 
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision 1.2 $
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   vzr_util.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date    2003-12-11.16.10.36

 \brief macro interne pour vizir
 */

#ifndef __VZRUTIL__
#define __VZRUTIL__

#include "vzr_struct.h"

#ifdef min
#undef min
#endif
#define min(a,b) (a>b?b:a)

#ifdef max
#undef max
#endif
#define max(a,b) (a>b?a:b)

#define cmax 101   /* utilise dans rang, doit etre sup a nbcrit */
#define DIM_PILE 10000 /* taille max de la pile de migrants  */
#define suiv(i) ((i)<DIM_PILE-1 ? ((i)+1) : 0)

#define MULTI   0 /* multi objectif */
#define MONO    1 /* mono objectif */
#define MONOC   2 /* mono objectif avec contraintes */
#define MULTIC  3

#define END     0
#define PEND    3
#define RUN     1
#define START   2
#define STOP    4
#define CONV    8

#define PRO_CALL(obj, meth, ...) obj->meth(obj->data, __VA_ARGS__)
#define PRO_CREATE(obj) obj->create(obj->data)
#define PRO_DEALLOC(obj) obj->dealloc(obj)

#endif
