//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2022 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any 
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision 1.2 $
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   gramschmitd.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date    2012-07-12.11.20.08

 \brief Gram Schmidt orthonormalisation methode
 */

#ifndef __GRAM_SCHMIDT__
#define __GRAM_SCHMIDT__

#ifdef __cplusplus
extern "C"
{
#endif

void sorm_gramschmidt(int size, double *vec, double *rot);
void sorm_rotation(int size, double *rot, double *in, double *out);

#ifdef  __cplusplus
}
#endif

#endif
