//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2022 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////

#ifndef CPPUNITEST_TRELIABILITY_H
#define CPPUNITEST_TRELIABILITY_H

// CppUnit
#include <cppunit/extensions/HelperMacros.h>
#include <cppunit/Test.h>

// Uranie
#include "TDataServer.h"

using namespace URANIE::DataServer;

class TFormSormTest: public CPPUNIT_NS::TestFixture
{
    CPPUNIT_TEST_SUITE (TFormSormTest);

    CPPUNIT_TEST (testDirect);
    CPPUNIT_TEST (testGradient);

    CPPUNIT_TEST_SUITE_END();

public:
    //---------------------------------------------
    /** @name Constructor and Destructor
     **/
    //@{
    //! Default constructor
    TFormSormTest();

    //! Default destructor
    virtual ~TFormSormTest();
    //@}

    //---------------------------------------------
    /** @name SetUp and internals methods
     **/
    //@{
    void setUp();
    void tearDown();

    //@}
    //---------------------------------------------
    /** @name Unit Tests
     The list of unit test
     **/
    //@{
    void testDirect();
    void testGradient();
    //@}

private:
    void *_p2fFselect;

    void validate(TDataServer &tds);

};

#endif

