/* differents cas de saturation des contraintes
 #define ZZZ 0.4 // 3 saturées
 #define ZZZ 0.55 // 2 saturées
 #define ZZZ 0.65 // aucune saturées
 * */
#define ZZZ 0.55 // 2 saturées

/* possible solver
 * direct
 #define SOLV TNloptCobyla
 * lagragien direct
 #define SOLV TNloptBobyqa //doesn't work on this problem
 #define SOLV TNloptPraxis
 #define SOLV TNloptNelderMead
 #define SOLV TNloptSubplexe
 * */
#define SOLV TNloptCobyla

using namespace URANIE::DataServer;
using namespace URANIE::Relauncher;
using namespace URANIE::Reoptimizer;
using namespace URANIE::Reliability;

/********** User Function *****************/
static void fselect(double *in, double *res)
{
    double x, y;

    x = in[0];
    y = in[1];
    /* critere */
    // cumul des distances aux points (1,0.5,ZZZ) et (0.5,1,ZZZ)
    res[0] = y * y * y - x;
}

/********** Optimization  *****************/
void test_TNloptForm()
{
    /* inputs */
    TNormalDistribution x1("x1"), x2("x2");
    /* outputs */
    TAttribute cont("seuil");
    /* starting point */
    double start[] =
    { -2.5, 0.5 };

    /* code */
    TSimpleTransform fobj;
    fobj.setParameters(2, &x1, &x2);

    TCJitEval fcont(&fselect);
    fcont.setInputs(2, &x1, &x2);
    fcont.setOutputs(1, &cont);

    TFormEval code(&fobj, &fcont);
    TGreaterFit it(3.0);
    code.addConstraint(&cont, &it);

    /* tds */
    TDataServer tds("toto", "tds for vizir test");
    code.addAllInputs(&tds);

    /*** FORM ***/
    /* optimizer */
    SOLV solv;
    TNlopt nlo(&tds, &code, &solv);
    code.addObjective(&nlo);

    /* resolution */
    nlo.setStartingPoint(2,start);
    nlo.solverLoop();

    /* resultats */
    tds.getTuple()->Scan("*");

    /*** SORM ***/
    TSorm sorm(&tds, &code);

    sorm.solverLoop();

    /* resultats */
    tds.getTuple()->Scan("*");

}
