//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2022 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any 
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision 1.2 $
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TVizirIsland.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date    2012-02-10.11.12.08

 \brief pseudo repartition en ilot homogene
 */

#ifndef __VIZIR_ISLAND__
#define __VIZIR_ISLAND__

//ROOT
#include "Rtypes.h"

//URANIE
#include "Reoptimizer.h"
#include "TVizirShare.h"

#include "TDataServer.h"
#include "TRun.h"
#include "TEval.h"

struct vzrtribe;

namespace URANIE
{
namespace Reoptimizer
{

class TVizirIsland: public TVizirShare
{
protected:
    int _ilot;

    void run(struct vzrtribe *all);

public:
    TVizirIsland(URANIE::DataServer::TDataServer *tds,
            URANIE::Relauncher::TRun *run, TVizirSolver *algo);
    TVizirIsland(URANIE::DataServer::TDataServer *tds,
            URANIE::Relauncher::TEval *fun, TVizirSolver *algo);
    virtual ~TVizirIsland()
    {
    }

    // parameter
    void setIsland(int size)
    {
        _ilot = size;
    }

    /** @name TMaster protocole **/
    virtual void solverLoop();

    ClassDef(URANIE::Reoptimizer::TVizirIsland, ID_REOPTIMIZER)
};

}
} //namespace
#endif
