/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2015-2022 CEA/DES
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   pso_query.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2015-08-24
 
 \brief  particle swarm api
*/

#ifndef __PSO_QUERY__
#define __PSO_QUERY__

#include "swarm/pso_struct.h"
#include "vizir/vzrfun_std.h"

#ifdef __cplusplus
extern "C" {
#endif

//struct vzrfitnessbuild *vzrfunstd_create(int (*)(vzrgene_t*, double*, void *), void *);

VZRLIB_EXPORT struct psoswarm *pso_init(int nbin, int nbout, int nbcont, double prec);
VZRLIB_EXPORT void pso_particle(struct psoswarm *self, int nbpart);
VZRLIB_EXPORT int pso_prepare(struct psoswarm *self, int step, int stop, int nbeval);
VZRLIB_EXPORT int pso_build(struct psoswarm *self, int nbpart, int nbeval, int stop);
VZRLIB_EXPORT int pso_resume(struct psoswarm *self, int nbeval, char *nfile);
VZRLIB_EXPORT void pso_dealloc(struct psoswarm *self);

//VZRLIB_EXPORT struct psoglobalbuild *psoglobalstd_create(int size, int step);
//VZRLIB_EXPORT struct psolocalbuild *psolocalstd_create(int size, int step);

VZRLIB_EXPORT void pso_run(struct psoswarm *self);
VZRLIB_EXPORT void pso_start(struct psoswarm *self);
VZRLIB_EXPORT void pso_wait(struct psoswarm *self);
VZRLIB_EXPORT int pso_running(struct psoswarm *self);
VZRLIB_EXPORT void pso_dump(struct psoswarm *self, char *nfile);

#ifdef __cplusplus
} /* end of extern "C" */
#endif

#endif
