/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2008-2022 CEA/DES
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   vzr_aleas.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2008-03-17
 
 \brief  sur couche thread-safe au generateur de nombre aleatoire mt19937
*/

#ifndef __VZR_ALEAS__
#define __VZR_ALEAS__

#include "vizir/vzr_config.h"

#ifdef __cplusplus
extern "C" {
#endif

VZRLIB_EXPORT void mt_init(int);

VZRLIB_EXPORT double mt_real1(void);
VZRLIB_EXPORT double mt_real2(void);
VZRLIB_EXPORT double mt_real3(void);
VZRLIB_EXPORT double mt_gauss(void);
VZRLIB_EXPORT long mt_int(long);

#ifdef __cplusplus
}
#endif

#endif
