/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2014-2022 CEA/DES
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   vzr_pair.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2014-01-29
 
 \brief  gestion appairage
*/


#ifndef __VZRPAIR__
#define __VZRPAIR__

#include "vizir/vzrpop_api.h"
#include "vizir/vzrpop_util.h"

struct pair {
    short one, two;
    double cost;
};

struct local {
    short prof;
    int ratio, seuil, done;
    double cut;
    struct pair *fit;
};

void pair_affectation(struct voisin *knn, struct local *self, int siz, struct vzrpop *pop);
void pair_vorder(struct local *loc, int siz, struct vzrpop *pop, int *simil);
void modal_vorder(struct local *loc, int siz, struct vzrpop *pop, int *simil);

#endif
