/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2009-2022 CEA/DES
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   vzrfifo_api.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2009-09-11
 
 \brief  gestion de fifo pour immigration
*/

#ifndef __VZR_FIFO__
#define __VZR_FIFO__

#include "vizir/vzr_config.h"

/* structure */
struct vzrfifo {
    int     bas, // index du bas de pile
            sommet, // index du haut de la pile
            taille, // taille de la pile courante
            maxi; // taille de la pile
    int     nbgene; // taille des données
    pthread_mutex_t     lock;
    vzrgene_t     **fifo; // fifo des migrants
};

/* private */
extern void vzrfifo_init(struct vzrfifo *self, int nbgene);
extern int vzrfifo_build(struct vzrfifo *self, int taille);
extern int vzrfifo_put(struct vzrfifo *self, vzrgene_t *x);
extern int vzrfifo_get(struct vzrfifo *self, vzrgene_t *x);
extern void vzrfifo_reset(struct vzrfifo *self);
extern void vzrfifo_dealloc(struct vzrfifo *self);

#endif

