
using namespace URANIE::DataServer;
using namespace URANIE::Relauncher;
using namespace URANIE::Reoptimizer;

void funAllCost(Double_t *param, Double_t *res)
{
    Double_t x = param[0];
    Double_t y = param[1];
    /* l'epaisseur */
    res[0] = x - y;
    /* critere section */
    res[1] = 10 * (x * x - y * y);
    /* critere deformation */
    res[2] = 1. / (x * x * x * x - y * y * y * y);
}

void test_TVizirMultiConstraint()
{

    TAttribute x("x", 0.0, 1.0), y("y", 0.0, 1.0), c1("cont1"), o1("obj1"), o2(
            "obj2");

    TCJitEval code(&funAllCost);
    code.setInputs(2, &x, &y);
    code.setOutputs(3, &c1, &o1, &o2);

    TDataServer tds("vizirDemo", "Param de l'opt vizir pour la barre");
    tds.addAttribute(&x);
    tds.addAttribute(&y);

    TVizirGenetic solv;
    //solv.setSoftConstraintPolicy();
    solv.setSize(1000, 100000);
    TVizir2 vzrmulti(&tds, &code, &solv);
    vzrmulti.addObjective(&o1);
    vzrmulti.addObjective(&o2);
    TGreaterFit epaisseur(0.4);
    vzrmulti.addConstraint(&c1, &epaisseur);

    //vzrmulti.drawZoneAdmissible(0);
    //vzrmulti.drawImageZoneAdmissible();  

    /* resolution */
    vzrmulti.solverLoop();

    /* solution */

    tds.drawTufte("x:y");
    //tds.drawTufte("c1:c2");
    //tds.startViewer();
    tds.getTuple()->Scan("*");

    tds.exportData("_vizir_.dat");

}
