//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2022 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TArchimedianCopula.cxx
 \author Fabrice Gaudier <fabrice.gaudier@cea.fr>
 \date   mer oct 17 17:36:39 CEST 2012
 
 \brief Implementat de la classe URANIE::Sampler::TArchimedianCopula
 
 */

////// URANIE
#include "TArchimedianCopula.h"
#include "UExceptions.h"

ClassImp (URANIE::Sampler::TArchimedianCopula)

namespace URANIE
{
namespace Sampler
{
TArchimedianCopula::TArchimedianCopula(URANIE::DataServer::TDataServer *tds,
        Double_t dparam, Int_t nCalcul) :
        TCopula(tds, "ArchimedianCopula", nCalcul), _dparam(dparam)
{
    if (_blog)
        cout << " ** constructor TArchimedianCopula" << endl;
}
TArchimedianCopula::~TArchimedianCopula()
{
    if (_blog)
        cout << " ** destroy TArchimedianCopula" << endl;
}

////////////////////////////////////////////////////////////
//  Printing Log
////////////////////////////////////////////////////////////
void TArchimedianCopula::printLog(Option_t *option)
{
    cout << "TArchimedianCopula::printLog[" << option << "]" << endl;
    cout << " ** Parameter [" << _dparam << "]" << endl;
}

} // Fin du namespace Sampler
} // Fin du namespace URANIE

