//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2022 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
#ifndef TNORMALE_H
#define TNORMALE_H

#include <iostream>
#include "Rtypes.h"

#ifndef TDISTRIBUTION_H
#include "TDistribution.h"
#endif

#ifndef ROOT_TNtupleD
#include "TNtupleD.h"
#endif

#ifndef ROOT_TFile
#include "TFile.h"
#endif

#ifndef ROOT_TVectorD
#include "TVectorD.h"
#endif

#ifndef ROOT_TMatrixD
#include "TMatrixD.h"
#endif

#ifndef ROOT_TDecompChol
#include "TDecompChol.h"
#endif

class TNormale: public TDistribution
{

private:
public:
    TNormale();
    TNormale(TVectorD M, TMatrixD A);
    ~TNormale();
    Double_t eval(TVectorD x);
    Double_t eval(Double_t x);
    void acceptationRejet();
    Double_t getObs();
    void simulationPolaire();
    TVectorD vectCentreReduit();
    TVectorD getObsMultiDim();
    void simVectGaussien();ClassDef(TNormale, ID_SAMPLER);
    // DDDfsf
};
#endif

