//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2022 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision$
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TSamplerDeterminist.cxx
 \author Fabrice Gaudier <fabrice.gaudier@cea.fr>
 \date   Tue Mar  7 14:06:02 2006
 
 \brief  Creation of the abstract class TSamplerDeterminist
 
 
 */
#include <ctime>

////// URANIE
#include "TSamplerDeterminist.h"

ClassImp (URANIE::Sampler::TSamplerDeterminist);

namespace URANIE
{
namespace Sampler
{

TSamplerDeterminist::TSamplerDeterminist(URANIE::DataServer::TDataServer *tds,
        Option_t *option, Int_t ns) :
        TSampler(tds, option, ns)
{
    TString opt = option;
    opt.ToLower();
}

// destructor
TSamplerDeterminist::~TSamplerDeterminist()
{
}

////////////////////////////////////////////////////////////
//  Printing Log
////////////////////////////////////////////////////////////
void TSamplerDeterminist::printLog(Option_t *option)
{
    cout << "TSamplerDeterminist::PrintLog[" << option << "]" << endl;
}

} // Fin du namespace Sampler
} // Fin du namespace URANIE

// fin du fichier $RCSfile$.
