//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2022 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision$
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TestTOATDesign.h
 \author Nicolas Gilardi
 \date   $Date$
 
 \brief  Test file of the class URANIE::Sampler::TOATDesign
 
 Created: 2012-08-21
 
 */
#ifndef CPPUNITEST_TOATDesign_H
#define CPPUNITEST_TOATDesign_H

//CPPUNIT
#include <cppunit/extensions/HelperMacros.h>
//#include <cppunit/portability/CppUnitDeque.h>
#include <cppunit/Test.h>
#include <cppunit/TestFailure.h>
#include <cppunit/TestResultCollector.h>

//URANIE           
#include "TOATDesign.h"
#include "TStochAttribut.h"
#include "UExceptions.h"

class TOATDesignTest: public CPPUNIT_NS::TestFixture
{
    CPPUNIT_TEST_SUITE (TOATDesignTest);
    CPPUNIT_TEST (testConstructor);
    CPPUNIT_TEST (testSetOptions);
    CPPUNIT_TEST (testGetHasData);
    CPPUNIT_TEST (testGetNumberOfModifications);
    CPPUNIT_TEST (testGetSamplingMode);
    CPPUNIT_TEST (testGetGenerationMode);
    CPPUNIT_TEST (testSetRangeDouble);
    CPPUNIT_TEST (testSetRangeString);
    CPPUNIT_TEST (testGetChangingAttList);
    CPPUNIT_TEST (testGetRangeInformation);
    CPPUNIT_TEST (testGetNominalValueTuple);
    CPPUNIT_TEST (testGenerateSample);
    CPPUNIT_TEST (testGenerateSampleWithStepValue);
    CPPUNIT_TEST_SUITE_END();

public:
    TOATDesignTest();

    /// Destructor.
    virtual ~TOATDesignTest();

    void setUp();
    void tearDown();
    //---------------------------------------------
    /** @name Unit Tests
     The list of unit test
     **/
    //@{
    void testConstructor();
    void testSetOptions();
    void testGetHasData();
    void testGetNumberOfModifications();
    void testGetSamplingMode();
    void testGetGenerationMode();
    void testSetRangeDouble();
    void testSetRangeString();
    void testGetChangingAttList();
    void testGetRangeInformation();
    void testGetNominalValueTuple();
    void testGenerateSample();
    void testGenerateSampleWithStepValue();
    //@}

private:
    URANIE::Sampler::TOATDesign *mySampling;
};

#endif  // CPPUNITEST_TOATDesign_H
