//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2022 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision$
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TestTUncertModeler.h
 \author maud Salvoldi (OCC/Areva group)
 \date   $Date$
 
 \brief  Test File of the class URANIE::DataServer::TUncertModeler
 
 Created: wen dec 21 16:52:44 2011
 
 */
#ifndef CPPUNITEST_TESTTUNCERTMODELER_H
#define CPPUNITEST_TESTTUNCERTMODELER_H

#include <cppunit/extensions/HelperMacros.h>
//#include <cppunit/portability/CppUnitDeque.h>
#include <cppunit/Test.h>
#include <cppunit/TestFailure.h>
#include <cppunit/TestResultCollector.h>

#include "TUncertModeler.h"
#include "TDataServer.h"
#include "TAttribute.h"
#include "UExceptions.h"

/*! \class TUncertModelerTest
 * \brief Unitary tests for TUncertModeler.
 */
class TUncertModelerTest: public CPPUNIT_NS::TestFixture
{
    CPPUNIT_TEST_SUITE (TUncertModelerTest);
    CPPUNIT_TEST (testTUncertModelerConstructor);
    CPPUNIT_TEST (throwExceptionTUncertModelerConstructorTdsNull);CPPUNIT_TEST_SUITE_END();

public:
    /*! Constructs a TUncertModelerTest object.
     */
    TUncertModelerTest();

    /// Destructor.
    virtual ~TUncertModelerTest();

    void setUp();
    void tearDown();

    //---------------------------------------------
    /** @name Unit Tests
     The list of unit test
     **/
    //@{
    //! 
    void testTUncertModelerConstructor();
    //!
    void throwExceptionTUncertModelerConstructorTdsNull();

    //@}

private:
    URANIE::DataServer::TDataServer *_tds;
    URANIE::UncertModeler::TUncertModeler *_tks;
};

#endif  // CPPUNITEST_TESTTUNCERTMODELER_H
