/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2013-2022 CEA/DES
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   TComponentRun.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2014-10-16
 
 \brief  pseudo runner for salome component
*/


#ifndef __COMPONENTRUN__
#define __COMPONENTRUN__

#include "TShareRun.h"

namespace URANIE
{
namespace Relauncher
{

class TComponentRun: public TSimpleRun
{
protected:
    TEval *_workfun;

public:
    TComponentRun(TEval *);
    virtual ~TComponentRun(void);

    virtual void startSlave(void);
    virtual void stopSlave(void);

    virtual int get(long &);

    int eval(vector<URANIE::DataServer::UEntry*> *, 
        vector<URANIE::DataServer::UEntry*> *, int =0);
    
    ClassDef(URANIE::Relauncher::TComponentRun, ID_RELAUNCHER)
};

}} //namespace

#endif
