//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2022 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any 
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision 1.1 $
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TFakeEval.cxx
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date    2012-12-20.09.57.12

 \brief   declaration de prototype
 */

#include "TFakeEval.h"

ClassImp (URANIE::Relauncher::TFakeEval);

namespace URANIE
{
namespace Relauncher
{

// int TFakeMulti::meval(double *in, double **out)
// {
//     std::cout << "CALL to a FAKE Eval\n" << std::endl;
//     return -1;
// }

TFakeEval::TFakeEval():
    TSimpleEval()
{
}

int TFakeEval::eval(vector<URANIE::DataServer::UEntry*> *in, 
    vector<URANIE::DataServer::UEntry*> *out, int ncalc)
{
    UNUSED(in, out, ncalc);
    std::cout << "CALL to a FAKE Eval\n" << std::endl;
    return -1;
}


}
} //namespace

