//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2022 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any 
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision 1.4 $
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TRun.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date    2011-03-30.11.00.16

 \brief 
 */

#ifndef __TRun__
#define __TRun__

//ROOT
#include "Rtypes.h"

// Uranie
#include "Relauncher.h"
#include "TEval.h"

#define MASTERBLOCK(run) int mb; for((run).startSlave(), mb=0; (run).onMaster() && !mb ; (run).stopSlave(), mb++)

namespace URANIE
{
namespace Relauncher
{

class TRun
{
public:
    Int_t _ncpus;

    virtual ~TRun()
    {
    }
    ;

    virtual TEval *getEval() =0;

    virtual void startSlave() = 0;
    virtual Bool_t onMaster() = 0;
    virtual void stopSlave() = 0;

    virtual void put(long, vector<URANIE::DataServer::UEntry*> *in, vector<URANIE::DataServer::UEntry*> *out, int icalc=0) = 0;
    virtual Bool_t readyToGet() = 0;	
    virtual int get(long &) = 0;

    ClassDef(URANIE::Relauncher::TRun, ID_RELAUNCHER)
};

}
} //namespace

#endif
