
#ifdef JIT
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <iostream>

#include "TAttribute.h"
#include "TFakeEval.h"
#include "TCoroutineRun.h"
#include "TDataServer.h"
#include "TLauncher2.h"

#endif

using namespace URANIE::DataServer;
using namespace URANIE::Relauncher;

void testIshigamiPcl(TDataServer **ptds, TCoroutineRun **trun, int *ress)
{

    // inputs
    TAttribute x1("x_{1}");
    TAttribute x2("x_{2}");
    TAttribute x3("x_{3}");
    // output
    TAttribute ct("Ishigami");

    // Ishigami prototype
    TFakeEval code;
    code.addInput(&x1);
    code.addInput(&x2);
    code.addInput(&x3);
    code.addOutput(&ct);

    // runner
    TCoroutineRun run(&code, *ress);
    *trun = &run;
    run.startSlave();
    if (run.onMaster()) {
        TDataServer tds("tds", "Ishigami coroutine tds");
        *ptds = &tds;
        code.addAllInputs(&tds);
        tds.fileDataRead("Ishigami.dat", kFALSE, kTRUE);
        
        URANIE::Relauncher::TLauncher2 launch(&tds, &run);

        // resolution
        launch.solverLoop();

        run.stopSlave();
    }
}
