#!/usr/bin/env python

import ROOT
import math

def ReadIt(v1, w1, v2, w2) :

    ref=["zero","one","two","three","four","five","six","seven","eight","nine"]
    thev1=987654321; thev2=987654321;

    if ref.count(w1) != 0 :
        if ref.index(w1) >= len(v1) : thev1 = -123456789
        else : thev1 = v1[ ref.index(w1) ]
        pass

    if ref.count(w2) != 0 :
        if ref.index(w2) >= len(v2) : thev2 = -123456789
        else : thev2 = v2[ ref.index(w2) ]
        pass
    
    return [thev1, thev2]

# ------------------------------------------------------------------------------

# output attribute
thev1 = ROOT.URANIE.DataServer.TAttribute("thev1")
thev2 = ROOT.URANIE.DataServer.TAttribute("thev2")

# tds
tds = ROOT.URANIE.DataServer.TDataServer("tdsreadmt", "tds for Python multitype function")
tds.fileDataRead("readmultitype_sampling.dat")

# code
code = ROOT.URANIE.Relauncher.TPythonEval(ReadIt)
code.addInput(tds.getAttribute("v1"))
code.addInput(tds.getAttribute("w1"))
code.addInput(tds.getAttribute("v2"))
code.addInput(tds.getAttribute("w2"))
code.addOutput(thev1)
code.addOutput(thev2)

# run
run = ROOT.URANIE.Relauncher.TSequentialRun(code)
run.startSlave()
if (run.onMaster()) :
    # launcher
    launch = ROOT.URANIE.Relauncher.TLauncher2(tds, run)
    launch.solverLoop()

    tds.exportData("_output_testReadmtSequentialPython_.dat");

    run.stopSlave()
