
void multiply(double *x, double *y)
{
    URANIE::DataServer::TDataServer test("test","notindir");
    test.keepFinalTuple(false);
    test.fileDataRead("flowrateUniformDesign.dat",false);
    
    double max=-1000000;
    for(int i=0; i<test.getNPatterns(); i++)
    {
        double val = test.getValue("ystar",i);
        max = ((val>=max) ? val : max); 
    }
    y[0] = max * x[0];

}

void testThreadSafe(bool threaded=false)
{
    if(threaded)
        ROOT::EnableThreadSafety();  // part of the solution

    URANIE::DataServer::TUniformDistribution x("multiplier",1,10);
    URANIE::DataServer::TAttribute    MultMean("MultMean");

    URANIE::Relauncher::TCJitEval eval(multiply);
    eval.addInput(&x);
    eval.addOutput(&MultMean);

    URANIE::Relauncher::TThreadedRun run(&eval,4);
    run.startSlave();

    if( run.onMaster() )
    {
        URANIE::DataServer::TDataServer tds("pouet","pouet_notindir");
        tds.addAttribute(&x);
    
        URANIE::Sampler::TSampling sam(&tds,"lhs",24);
        sam.setSeed(123456);
        sam.generateSample();

        URANIE::Relauncher::TLauncher2 launch(&tds, &run);
        launch.solverLoop();
        tds.getTuple()->SetScanField(-1);
        tds.scan();
        tds.exportData("_ThreadedTest_.dat");

        run.stopSlave();
    }

}
