#ifndef RESOURCEXMLHOOK_H
#define RESOURCEXMLHOOK_H

#include <cppunit/XmlOutputterHook.h>

class ResourceModel;

/// XML output hook to add test timing and test hierarchy timing.
class ResourceXmlHook : public CPPUNIT_NS::XmlOutputterHook
{
public:
  /*! Constructs a ResourceXmlHook object.
   */
  ResourceXmlHook( ResourceModel *model );

  /// Destructor.
  virtual ~ResourceXmlHook();

  void endDocument( CPPUNIT_NS::XmlDocument *document );

  void failTestAdded( CPPUNIT_NS::XmlDocument *document,
                      CPPUNIT_NS::XmlElement *testElement,
                      CPPUNIT_NS::Test *test,
                      CPPUNIT_NS::TestFailure *failure );

  void successfulTestAdded( CPPUNIT_NS::XmlDocument *document,
                            CPPUNIT_NS::XmlElement *testElement,
                            CPPUNIT_NS::Test *test );

  void statisticsAdded( CPPUNIT_NS::XmlDocument *document,
                        CPPUNIT_NS::XmlElement *statisticsElement );

private:
  /// Prevents the use of the copy constructor.
  ResourceXmlHook( const ResourceXmlHook &other );

  /// Prevents the use of the copy operator.
  void operator =( const ResourceXmlHook &other );

private:
  ResourceModel *m_model;
};

// Inlines methods for ResourceXmlHook:
// -----------------------------------

#endif  // RESOURCEXMLHOOK_H
