//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2022 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
/*!
 \file   TestTBaseModel.h
 \author Fabrice Gaudier <fabrice.gaudier@cea.fr>
 \date   $Date$
 
 \brief  Test File of the class URANIE::XMLProblem::TBaseModel
 
 Created: 2015/10/27 14:03
 
 */
#ifndef CPPUNITEST_TESTTBASEMODEL_H
#define CPPUNITEST_TESTTBASEMODEL_H

#include <cppunit/extensions/HelperMacros.h>
//#include <cppunit/portability/CppUnitDeque.h>
#include <cppunit/Test.h>
#include <cppunit/TestFailure.h>
#include <cppunit/TestResultCollector.h>

/*!
 @class TBaseModelTest
 @brief Unit tests for TBaseModel.
 
 The units tests are :
 \li Names \ref testNames
 \li Title \ref testTitles
 
 */

// Uranie
#include "TBaseModel.h"
#include "TDataServer.h"

class TBaseModelTest: public CPPUNIT_NS::TestFixture
{
    CPPUNIT_TEST_SUITE (TBaseModelTest);
    CPPUNIT_TEST (testConstructors);
    CPPUNIT_TEST (testInitExport);
    CPPUNIT_TEST_SUITE_END();

public:
    //---------------------------------------------
    /** @name Constructor and Destructor
     **/
    //@{
    //! Default constructor
    TBaseModelTest();

    //! Default destructor
    virtual ~TBaseModelTest();

    void setUp();
    void tearDown();
    //@}

    //---------------------------------------------
    /** @name Unit Tests
     The list of unit test
     **/
    //@{ 
    //! Test of the constructors of the TBaseModel
    void testConstructors();
    //! Test of the initExport Method
    void testInitExport();
    //@}

private:
    URANIE::XMLProblem::TBaseModel *_tbm1;
    URANIE::XMLProblem::TBaseModel *_tbm2;
    URANIE::XMLProblem::TBaseModel *_tbm3;
};

#endif
// CPPUNITEST_TBASEMODEL_H
