<?xml version="1.0" standalone="yes" ?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

<xsl:template match="/">
<HTML>
<HEAD>
<TITLE><xsl:apply-templates select="/Problem/Header/@name"/> - XML uranie</TITLE>
</HEAD>
<BODY>
  	<xsl:apply-templates select="/Problem/Header"/>
  	<xsl:apply-templates select="/Problem/DataDictionary"/>
  	<xsl:apply-templates select="/Problem/Sampler"/>
  	<xsl:apply-templates select="/Problem/Launcher"/>
</BODY>
</HTML>
</xsl:template>



<xsl:template match="/Problem/Header">
  <H1>  XML Problem uranie : <xsl:value-of select="@name"/> (<xsl:value-of select="@title"/>) </H1>
</xsl:template>



<xsl:template match="/Problem/DataDictionary">
    <H2>DataServer</H2>
    <xsl:choose>
	<xsl:when test="DataField">
		<TABLE>
			<TR>
				<TH>Name</TH>
				<TH>law</TH>
				<TH>Min</TH>
				<TH>Max</TH>
				<TH>Mean</TH>
				<TH>Sigma</TH>
			</TR>
		  	<xsl:apply-templates select="/Problem/DataDictionary/DataField"/>
		</TABLE>
	</xsl:when>
	<xsl:otherwise>
	    <SPAN class="good">No attributes.</SPAN>
	</xsl:otherwise>
    </xsl:choose>
</xsl:template>

<xsl:template match="/Problem/DataDictionary/DataField">
	<TR>
	<TD valign='top'><xsl:value-of select="@name"/></TD>
	<TD valign='top'><xsl:value-of select="@law"/></TD>
		  <TD valign='top'><xsl:value-of select="@min"/></TD>
		  <TD valign='top'><xsl:value-of select="@max"/></TD>
		  <TD valign='top'><xsl:value-of select="@mean"/></TD>
	          <TD valign='top'><xsl:value-of select="@std"/></TD>
	</TR>
</xsl:template>



<xsl:template match="/Problem/Sampler">
    <H2>Sampler</H2>
<ul>
<li> Method : "<xsl:value-of select="@method"/>"</li>
<li> Size  : <xsl:value-of select="@N"/></li>
    <xsl:choose>
	<xsl:when test="@export">
<li>Data file : <xsl:value-of select="@export"/></li>
	</xsl:when>
	<xsl:otherwise>
	    <SPAN class="good">No export.</SPAN>
	</xsl:otherwise>
    </xsl:choose>

</ul>

</xsl:template>

<xsl:template match="/Problem/Launcher">
    <H2>Launcher</H2>
<ul>
    <xsl:choose>
	<xsl:when test="@macro">
		<li> File Macro: <xsl:value-of select="@macro"/></li>
	</xsl:when>
    </xsl:choose>

    <li> Function  : <xsl:value-of select="@function"/></li>

    <xsl:choose>
	<xsl:when test="@input">
		<ul><li> Input: "<xsl:value-of select="@input"/>"</li></ul>
	</xsl:when>
    </xsl:choose>
    <xsl:choose>
	<xsl:when test="@output">
		<ul><li> Output: "<xsl:value-of select="@output"/>"</li></ul>
	</xsl:when>
    </xsl:choose>

    <xsl:choose>
	<xsl:when test="@export">
<li>Data file : <xsl:value-of select="@export"/></li>
	</xsl:when>
	<xsl:otherwise>
	    <SPAN class="good">No export.</SPAN>
	</xsl:otherwise>
    </xsl:choose>

</ul>

</xsl:template>


</xsl:stylesheet>
